
unit MainForm;

interface

uses
  Winapi.Windows, Winapi.Messages, Winapi.ShlObj,
  System.SysUtils, System.Classes, System.ImageList, System.Actions,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls,
  Vcl.ComCtrls, Vcl.Menus, Vcl.ImgList, Vcl.ToolWin, Vcl.StdCtrls, Vcl.AppEvnts,
  Vcl.ExtActns, Vcl.StdActns, Vcl.ActnList, Vcl.WinXCtrls, Vcl.WinXPanels,
  DropTarget, DragDrop, DropSource, DragDropFile,
  RzTreeVw, RzShellCtrls, RzShellIntf, RzStatus, Vcl.NumberBox,
  Vcl.TitleBarCtrls, Vcl.Imaging.pngimage;

type
  TGetHeaderItemFontColorEvent = procedure(Sender: TCustomListView; ItemIndex: Integer; var FontColor: TColor) of object;

  TListView = class(Vcl.ComCtrls.TListView)
  private
    FHeaderHandle: HWND;
    FOnGetHeaderItemFontColor: TGetHeaderItemFontColorEvent;
    procedure WMNotify(var AMessage: TWMNotify); message WM_NOTIFY;
    procedure CNMeasureItem(var Message: TWMMeasureItem); message CN_MEASUREITEM;
  protected
    procedure CreateWnd; override;
  published
    property OnGetHeaderItemFontColor: TGetHeaderItemFontColorEvent read FOnGetHeaderItemFontColor write FOnGetHeaderItemFontColor;
  end;

type
  TformMain = class(TForm)
    ilIDEs: TImageList;
    StatusBarMain: TStatusBar;
    lvMRUProjects: TListView;
    tlbProjectsList: TToolBar;
    searchboxProjectsList: TSearchBox;
    btnOpenSelectedProject: TToolButton;
    ilToolBar: TImageList;
    btnOpenSelInExplorer: TToolButton;
    btnCopyPath: TToolButton;
    pnlProjectListHeader: TPanel;
    imgHeader: TImage;
    ilHeader: TImageList;
    CardPanelMain: TCardPanel;
    cardMain: TCard;
    cardPreferences: TCard;
    btnClosePreferences: TButton;
    lblheaderCaption: TLabel;
    imgHeaderDropdown: TImage;
    pmIDESelection: TPopupMenu;
    menuitemALLDelphiMRUProjects: TMenuItem;
    AppEventsMain: TApplicationEvents;
    lblPrefHeader: TLabel;
    chkReadAllMRUAtProgramStart: TCheckBox;
    pnlHeaderDropdownArrow: TPanel;
    imgHeaderDropdownWhite: TImage;
    DropFileSourceMain: TDropFileSource;
    btnEmptySearchBox: TToolButton;
    chkHideNonExistingProjectFiles: TCheckBox;
    btnTempHideNonExistingFiles: TToolButton;
    chkShowAlternatingRowShadows: TCheckBox;
    btnGroup: TToolButton;
    pmGroup: TPopupMenu;
    menuitemByYear: TMenuItem;
    menuitemUngroup: TMenuItem;
    pnlMySeparator: TPanel;
    pnlMySecondSeparator: TPanel;
    splMain: TSplitter;
    lblProjectName: TLabel;
    CardPanelProjectDetails: TCardPanel;
    cardProjectDetails: TCard;
    cardNoProjectSelected: TCard;
    pgcProjectDetails: TPageControl;
    tsGeneral: TTabSheet;
    lblCreatedDate: TLabel;
    lblLastAccessed: TLabel;
    tsExe: TTabSheet;
    btnShowDetailsPane: TToolButton;
    listboxExeFiles: TListBox;
    lblFrameworkType: TLabel;
    tsNotes: TTabSheet;
    richeditNotesEditor: TRichEdit;
    ilNotes: TImageList;
    ActionListNotes: TActionList;
    actFileNewCmd: TAction;
    FileOpenCmd: TFileOpen;
    actFileSaveCmd: TAction;
    FilePrintCmd: TPrintDlg;
    FileExitCmd: TFileExit;
    FileSaveAsCmd: TFileSaveAs;
    EditUndoCmd: TEditUndo;
    EditCutCmd: TEditCut;
    EditCopyCmd: TEditCopy;
    EditPasteCmd: TEditPaste;
    EditFontCmd: TFontEdit;
    FormatRichEditBoldCmd: TRichEditBold;
    FormatRichEditItalicCmd: TRichEditItalic;
    FormatRichEditUnderlineCmd: TRichEditUnderline;
    FormatRichEditStrikeOutCmd: TRichEditStrikeOut;
    FormatRichEditBulletsCmd: TRichEditBullets;
    FormatRichEditAlignLeftCmd: TRichEditAlignLeft;
    FormatRichEditAlignRightCmd: TRichEditAlignRight;
    FormatRichEditAlignCenterCmd: TRichEditAlignCenter;
    actSuperscriptCmd: TAction;
    actSubscriptCmd: TAction;
    pmNotes: TPopupMenu;
    menuitemBold: TMenuItem;
    menuitemItalic: TMenuItem;
    menuitemUnderline: TMenuItem;
    menuitemStrikeout: TMenuItem;
    menuitemIncreaseFontSize: TMenuItem;
    menuitemDecreaseFontSize: TMenuItem;
    menuitemN1: TMenuItem;
    menuitemN2: TMenuItem;
    menuitemSubscriptCmd: TMenuItem;
    FontDialog: TFontDialog;
    menuitemFont: TMenuItem;
    menuitemCopy: TMenuItem;
    menuitemPaste: TMenuItem;
    menuitemCut: TMenuItem;
    btnSaveRTF: TButton;
    menuitemBullets: TMenuItem;
    menuitemAlign: TMenuItem;
    menuitemAlignLeft: TMenuItem;
    menuitemAlignCenter: TMenuItem;
    menuitemAlignRight: TMenuItem;
    menuitemZoom: TMenuItem;
    menuitemZoomIN: TMenuItem;
    menuitemZoomOUT: TMenuItem;
    menuitemN3: TMenuItem;
    menuitemZoomDEFAULT: TMenuItem;
    menuitemColor: TMenuItem;
    menuitemColorForeground: TMenuItem;
    menuitemColorBackground: TMenuItem;
    dlgColor: TColorDialog;
    menuitemGroupByNotes: TMenuItem;
    lblUIFontSize: TLabel;
    menuitemGroupByAppType: TMenuItem;
    lblAppType: TLabel;
    pnlProjectDetailsHeader: TPanel;
    imgProjectDetails: TImage;
    il20: TImageList;
    lblExternalEditor: TLabel;
    edtExternalEditor: TEdit;
    btnLoadSelectedProjectInExternalEditor: TToolButton;
    menuitemGroupByFrameworkType: TMenuItem;
    tsFiles: TTabSheet;
    listboxProjectFiles: TListBox;
    menuitemIndentIncrease: TMenuItem;
    menuitemIndent: TMenuItem;
    menuitemIndentDecrease: TMenuItem;
    menuitemBulletsRoot: TMenuItem;
    menuitemCycleThroughDifferentBulletStyles: TMenuItem;
    lblExeInfo: TLabel;
    lblFilesInfo: TLabel;
    ilShellIcons: TImageList;
    ilDummy: TImageList;
    pmSearchBox: TPopupMenu;
    menuitemIncreaseTheWidthOfTheSearchBox: TMenuItem;
    menuitemDecreaseTheWidthOfTheSearchBox: TMenuItem;
    menuitemResetTheDefaultWidthOfTheSearchBox: TMenuItem;
    pnlPreferencesInternal: TRelativePanel;
    btnIncreaseUIFontSizeEx: TButton;
    btnDecreaseUIFontSizeEx: TButton;
    btnFilterProjectFilePath: TToolButton;
    btnFilterNotes: TToolButton;
    btnFilterSourceFiles: TToolButton;
    N4: TMenuItem;
    menuitemReloadNotesFile: TMenuItem;
    pnlProjectList: TPanel;
    pbProjects: TProgressBar;
    RzShellTreeGroups: TRzShellTree;
    pnlProjectGroups: TPanel;
    splProjectGroups: TSplitter;
    DropFileTargetGroups: TDropFileTarget;
    pmProjectGroups: TPopupMenu;
    menuitemPasteTheProjectFromTheClipboard: TMenuItem;
    menuitemCreateASubProjectGroup: TMenuItem;
    menuitemRenameProjectGroup: TMenuItem;
    menuitemRemoveProjectGroup: TMenuItem;
    ToggleSwitchGroupRecursive: TToggleSwitch;
    lblheaderListMode: TLabel;
    btnRemoveSelProjectFromGroup: TToolButton;
    menuitemPastePlainText: TMenuItem;
    imgHeaderGroup: TImage;
    RzVersionInfoMain: TRzVersionInfo;
    lblExeVersionInfo: TLabel;
    btnPasteProject: TToolButton;
    ilGroupStatus: TImageList;
    cardAbout: TCard;
    lblTitleAbout: TLabel;
    lblAboutVersion: TLabel;
    btnCloseAbout: TButton;
    RelativePanelAbout: TRelativePanel;
    lblAboutHomepage: TLabel;
    lblAboutEmail: TLabel;
    lblAboutProcessMemory: TLabel;
    ilCertificates: TImageList;
    imgCertificateApplication: TImage;
    imgCertificateCompany: TImage;
    lblCertificateApplication: TLabel;
    lblCertificateCompany: TLabel;
    btnShowPropertiesDialog: TButton;
    chkCustomizeRowHeight: TCheckBox;
    nbRowheight: TNumberBox;
    chkCustomizeTitleBarColor: TCheckBox;
    pnlTitleBar: TTitleBarPanel;
    dlgColorMain: TColorDialog;
    imgTitleBarMenu: TImage;
    pnlTitleBarMenu: TPanel;
    pmTitleBar: TPopupMenu;
    menuitemTitleBarPreferences: TMenuItem;
    ilMenus: TImageList;
    menuitemTitleBarShowTheMainPage: TMenuItem;
    menuitemTitleBarAbout: TMenuItem;
    lblThanks: TLabel;
    pnlUIOptions: TPanel;
    pnlInner: TPanel;
    lblUIOptions: TLabel;
    lblProjectListCount: TLabel;
    DropFileTargetProjectList: TDropFileTarget;
    lblDelphiVersion: TLabel;
    imgHeaderModeDropdownGray: TImage;
    pmProjectListMode: TPopupMenu;
    menuitemMODE_MRU: TMenuItem;
    menuitemMODE_GROUP: TMenuItem;
    menuitemMODE_COMBINED: TMenuItem;
    pmOpenInIDE: TPopupMenu;
    menuitemNoDelphiAppsFound: TMenuItem;
    pnlMySeparator2: TPanel;
    pnlMySeparator3: TPanel;
    chkShowInfoTips: TCheckBox;
    chkShowHintsInStatusBar: TCheckBox;
    lblHintHidePause: TLabel;
    nbHintHidePause: TNumberBox;
    lblSeconds: TLabel;
    menuitemGroupByDelphiVersion: TMenuItem;
    procedure actSubscriptCmdExecute(Sender: TObject);
    procedure actSubscriptCmdUpdate(Sender: TObject);
    procedure actSuperscriptCmdExecute(Sender: TObject);
    procedure actSuperscriptCmdUpdate(Sender: TObject);
    procedure AppEventsMainActivate(Sender: TObject);
    procedure menuitemALLDelphiMRUProjectsClick(Sender: TObject);
    procedure AppEventsMainDeactivate(Sender: TObject);
    procedure AppEventsMainHint(Sender: TObject);
    procedure btnCloseAboutClick(Sender: TObject);
    procedure btnClosePreferencesClick(Sender: TObject);
    procedure btnCopyPathClick(Sender: TObject);
    procedure btnDecreaseUIFontSizeClick(Sender: TObject);
    procedure btnEmptySearchBoxClick(Sender: TObject);
    procedure btnFilterNotesClick(Sender: TObject);
    procedure btnFilterProjectFilePathClick(Sender: TObject);
    procedure btnFilterSourceFilesClick(Sender: TObject);
    procedure btnGroupClick(Sender: TObject);
    procedure btnGroupMouseEnter(Sender: TObject);
    procedure btnGroupMouseLeave(Sender: TObject);
    procedure btnIncreaseUIFontSizeClick(Sender: TObject);
    procedure btnLoadSelectedProjectInExternalEditorClick(Sender: TObject);
    procedure btnOpenSelectedProjectClick(Sender: TObject);
    procedure btnOpenSelInExplorerClick(Sender: TObject);
    procedure btnPasteProjectClick(Sender: TObject);
    procedure btnRemoveSelProjectFromGroupClick(Sender: TObject);
    procedure btnShowDetailsPaneClick(Sender: TObject);
    procedure btnSaveRTFClick(Sender: TObject);
    procedure btnShowPropertiesDialogClick(Sender: TObject);
    procedure btnTempHideNonExistingFilesClick(Sender: TObject);
    procedure chkCustomizeRowHeightClick(Sender: TObject);
    procedure chkCustomizeTitleBarColorClick(Sender: TObject);
    procedure chkHideNonExistingProjectFilesClick(Sender: TObject);
    procedure chkShowInfoTipsClick(Sender: TObject);
    procedure DropFileSourceMainGetDragImage(Sender: TObject; const DragSourceHelper: IDragSourceHelper; var Handled: Boolean);
    procedure DropFileTargetGroupsDragOver(Sender: TObject; ShiftState: TShiftState; APoint: Winapi.Windows.TPoint; var Effect: Integer);
    procedure DropFileTargetGroupsDrop(Sender: TObject; ShiftState: TShiftState; APoint: Winapi.Windows.TPoint; var Effect: Integer);
    procedure DropFileTargetProjectListDrop(Sender: TObject; ShiftState:
        TShiftState; APoint: TPoint; var Effect: Integer);
    procedure edtExternalEditorChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure imgHeaderDropdownClick(Sender: TObject);
    procedure imgHeaderDropdownMouseEnter(Sender: TObject);
    procedure imgHeaderDropdownMouseLeave(Sender: TObject);
    procedure imgHeaderDropdownWhiteMouseEnter(Sender: TObject);
    procedure imgHeaderDropdownWhiteMouseLeave(Sender: TObject);
    procedure imgHeaderModeDropdownGrayClick(Sender: TObject);
    procedure imgHeaderModeDropdownGrayMouseEnter(Sender: TObject);
    procedure imgHeaderModeDropdownGrayMouseLeave(Sender: TObject);
    procedure imgTitleBarMenuClick(Sender: TObject);
    procedure imgTitleBarMenuMouseEnter(Sender: TObject);
    procedure imgTitleBarMenuMouseLeave(Sender: TObject);
    procedure lblAboutEmailClick(Sender: TObject);
    procedure lblAboutHomepageClick(Sender: TObject);
    procedure lblheaderCaptionClick(Sender: TObject);
    procedure lblheaderCaptionMouseEnter(Sender: TObject);
    procedure lblheaderCaptionMouseLeave(Sender: TObject);
    procedure lblheaderListModeClick(Sender: TObject);
    procedure lblheaderListModeMouseEnter(Sender: TObject);
    procedure lblheaderListModeMouseLeave(Sender: TObject);
    procedure listboxExeFilesDblClick(Sender: TObject);
    procedure listboxExeFilesDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure listboxExeFilesMeasureItem(Control: TWinControl; Index: Integer; var Height: Integer);
    procedure listboxExeFilesMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure listboxProjectFilesDblClick(Sender: TObject);
    procedure listboxProjectFilesDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure listboxProjectFilesMeasureItem(Control: TWinControl; Index: Integer; var Height: Integer);
    procedure listboxProjectFilesMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure lvMRUProjectsAdvancedCustomDrawItem(Sender: TCustomListView; Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage; var DefaultDraw: Boolean);
    procedure lvMRUProjectsAdvancedCustomDrawSubItem(Sender: TCustomListView; Item: TListItem; SubItem: Integer; State: TCustomDrawState; Stage: TCustomDrawStage; var DefaultDraw: Boolean);
    procedure lvMRUProjectsColumnClick(Sender: TObject; Column: TListColumn);
    procedure lvMRUProjectsCompare(Sender: TObject; Item1, Item2: Vcl.ComCtrls.TListItem; Data: Integer; var Compare: Integer);
    procedure lvMRUProjectsDblClick(Sender: TObject);
    procedure lvMRUProjectsDrawItem(Sender: TCustomListView; Item: TListItem; Rect: TRect; State: TOwnerDrawState);
    procedure lvMRUProjectsKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure lvMRUProjectsMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure lvMRUProjectsResize(Sender: TObject);
    procedure lvMRUProjectsSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
    procedure menuitemByYearClick(Sender: TObject);
    procedure menuitemColorBackgroundClick(Sender: TObject);
    procedure menuitemColorForegroundClick(Sender: TObject);
    procedure menuitemCreateASubProjectGroupClick(Sender: TObject);
    procedure menuitemDecreaseFontSizeClick(Sender: TObject);
    procedure menuitemDecreaseTheWidthOfTheSearchBoxClick(Sender: TObject);
    procedure menuitemFontClick(Sender: TObject);
    procedure menuitemGroupByAppTypeClick(Sender: TObject);
    procedure menuitemGroupByDelphiVersionClick(Sender: TObject);
    procedure menuitemGroupByFrameworkTypeClick(Sender: TObject);
    procedure menuitemGroupByNotesClick(Sender: TObject);
    procedure menuitemIncreaseFontSizeClick(Sender: TObject);
    procedure menuitemIncreaseTheWidthOfTheSearchBoxClick(Sender: TObject);
    procedure menuitemIndentDecreaseClick(Sender: TObject);
    procedure menuitemIndentIncreaseClick(Sender: TObject);
    procedure menuitemMODE_COMBINEDClick(Sender: TObject);
    procedure menuitemMODE_GROUPClick(Sender: TObject);
    procedure menuitemMODE_MRUClick(Sender: TObject);
    procedure menuitemPastePlainTextClick(Sender: TObject);
    procedure menuitemPasteTheProjectFromTheClipboardClick(Sender: TObject);
    procedure menuitemReloadNotesFileClick(Sender: TObject);
    procedure menuitemRemoveProjectGroupClick(Sender: TObject);
    procedure menuitemRenameProjectGroupClick(Sender: TObject);
    procedure menuitemResetTheDefaultWidthOfTheSearchBoxClick(Sender: TObject);
    procedure menuitemTitleBarAboutClick(Sender: TObject);
    procedure menuitemTitleBarPreferencesClick(Sender: TObject);
    procedure menuitemTitleBarShowTheMainPageClick(Sender: TObject);
    procedure menuitemUngroupClick(Sender: TObject);
    procedure menuitemZoomDEFAULTClick(Sender: TObject);
    procedure menuitemZoomINClick(Sender: TObject);
    procedure menuitemZoomOUTClick(Sender: TObject);
    procedure nbHintHidePauseChange(Sender: TObject);
    procedure pgcProjectDetailsChange(Sender: TObject);
    procedure pmGroupClose(Sender: TObject);
    procedure pmGroupPopup(Sender: TObject);
    procedure pmIDESelectionClose(Sender: TObject);
    procedure pmIDESelectionPopup(Sender: TObject);
    procedure pmNotesPopup(Sender: TObject);
    procedure pmOpenInIDEPopup(Sender: TObject);
    procedure pmProjectGroupsPopup(Sender: TObject);
    procedure pmTitleBarPopup(Sender: TObject);
    procedure pnlTitleBarCustomButtons0Click(Sender: TObject);
    procedure pnlTitleBarCustomButtons0Paint(Sender: TObject);
    procedure richeditNotesEditorChange(Sender: TObject);
    procedure richeditNotesEditorClick(Sender: TObject);
    procedure richeditNotesEditorKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure richeditNotesEditorLinkClick(Sender: TCustomRichEdit; const URL: string; Button: TMouseButton);
    procedure RzShellTreeGroupsClick(Sender: TObject);
    procedure RzShellTreeGroupsCustomDrawItem(Sender: TCustomTreeView; Node:
        TTreeNode; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure RzShellTreeGroupsMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure searchboxProjectsListChange(Sender: TObject);
    procedure ToggleSwitchGroupRecursiveClick(Sender: TObject);
  private
    const
      UNKNOWNSTR = 'Unknown';
      OPENLINKSTR = 'Open link: %s ?';
      NOTESFILENAME = 'Project Manager Notes.rtf';
      GROUPBYTAGVALUEOFFSET = 100;
      EMPTYSTR = 'Empty';
      FSearchFilterColor = clYellow;
      FAlternatingRowColor = $00E6E6E6;
      FRTFHASCHANGED = 1;
      VK_C_ = 67;
      VK_S_ = 83;
      Purpose_CREATE = 'CREATE';
      Purpose_RENAME = 'RENAME';
      WM_AFTER_SHOW = Winapi.Messages.WM_User + 300;
      WM_PARAMETER = Winapi.Messages.WM_User + 6;

      SEARCHBOXEMPTYTEXT_FilePaths = 'Filter the Project File Paths';
      SEARCHBOXEMPTYTEXT_Notes     = 'Filter the Project Notes';
      SEARCHBOXEMPTYTEXT_Sources   = 'Filter the Project Sources';
    var
      FAllMRULists: TStringList;
      FAllBdsExePaths: TStringList;
      FOldHint: string;
      FApplDir: string;
      FSettingsFile: string;
      FAfterProgramStart: Boolean;
      FIDESelectionMenuOpened: Boolean;

      FColumnSortedUp: array[0..1] of Boolean;
      FSortedColumn: Integer;
      FOldSortedColumn: Integer;

      FhHeaderFont: HFONT;

      FClickedMenuItem: TMenuItem;
      FClickedGroupMenuItem: TMenuItem;
      FpmGroupPopupIsOpened: Boolean;
      FExePairList: TStringList;
      FThisProjectPath: string;
      FDefaultExternalEditorFilepath: string;
      FExternalEditorFilepath: string;

      FIconIdx_DPR: Integer;
      FIconIdx_PAS: Integer;
      FIconIdx_DFM: Integer;
      FIconIdx_TXT: Integer;
      FIconIdx_DPK: Integer;
      FIconIdx_DCR: Integer;
      FIconIdx_EXE: Integer;

      FDefaultSearchBoxWidth: Integer;
      FOldFilterButton: TToolButton;
      FWinControlToDrag: TWinControl;
      FtsNotesCaption: string;
      FFirstSearchBoxWord: string;
      FDefaultCaptionColumnWidth: Integer;
      FDefaultModifiedColumnWidth: Integer;
      FOldLoadedNotesFile: string;
      FListOfSourceFilesContainingSearchWords: TStringList;
      FGroupNodeIndex: Integer;
      FProjectGroupsPath: string;
      CF_FILE: UINT;
      FProjectListGroupMode: Boolean;
      FCurrentProductVersion: string;
      FTitleBarColor: TColor;
      FPushPinImageIndex: Integer;
      FOldTitleBarColor: TColor;

    procedure WMAfterShow(var Msg: TMessage); message WM_AFTER_SHOW;
    procedure WMParameter(var Msg: TMessage); message WM_PARAMETER;
    procedure GetHeaderItemFontColor(Sender: TCustomListView; ItemIndex: Integer; var FontColor: TColor);
    procedure AddIDEMenuItem(const aVersion: Integer; aPopupMenu: TPopupMenu);
    procedure AddIDEMenuItems;
    procedure AddProjectLinkToSelectedProjectGroupFolder(const aProjectFilePath: string);
    procedure ButtonsSetIdealSize;
    procedure ClearProjectDetails;
    procedure DoColumnSort(aSender: TObject; const aColumnIndex: Integer; Clicked: Boolean = True);
    procedure DoFilterSearch(aFlag: Boolean = True);
    procedure EnableDisableActions(const Enable: Boolean);
    procedure EnableDisableHideNonExistingButton;
    procedure ExtractAllMRULists;
    procedure ExtractDelphiMRUList(const aVersion: Integer);
    function GetDelphiMRUList(const verstr: string; MRUList: TStringList): Boolean;
    function GetModifiedDateStr(const aFile: string): string;
    function GetCreatedDateStr(const aFile: string): string;
    function GetAccessedDateStr(const aFile: string): string;
    function GetFileText(const aTextFile: string): string;
    function GetSortedNoDuplicatesStringList: TStringList;
    function GetValueFromBetweenTags(const aText, aStartTag, aEndTag: string): string;
    procedure LoadAllMRUProjectsFromAllIIDEs(Sender: TObject);
    procedure menuitemSpecificIDEClick(Sender: TObject);
    procedure NewListInit;
    procedure ReClickClickedmenuItem;
    procedure RestoreWindowPlacementAndPreferences;
    procedure SaveWindowPlacementAndPreferences;
    procedure SetColumnHeaderFontBold;
    procedure SetHeader(const aIconIdx: Integer; const aHeaderCaption: string);
    procedure SetHeaderCaptionBackToNormal;
    procedure SetHeaderCaptionHot;
    procedure SetListHeaderSortArrow(const aColumnIndex: Integer; const aEnabled: Boolean);
    procedure ShowFilteredStatus(const VisibleCount: Integer);
    procedure ShowIDESelectionPopupMenu;
    procedure ShowProjectDetails;
    procedure ShowTextInStatusBar(const aText: string);
    procedure ShowUnfilteredStatus;
    function CurrText: TTextAttributes;
    procedure DoDecreaseSearchBoxWidth;
    procedure DoGroupByTagValues(const aStartTag, aEndTag: string);
    procedure DoHideNonExistingProjectFiles;
    procedure DoIncreaseSearchBoxWidth;
    procedure DoUngroup(Sender: TObject);
    function GetGroupID(const aGroupHeader: string): Integer;
    function GetIconIdx(const aExtension: string): Integer;
    function IsAnyGroupMenuItemChecked: Boolean;
    procedure TryOpenCodeFileInExternalEditor(const aFile: string);
    procedure OpenSelectedProjectInExternalEditor;
    procedure RichEditClearAll;
    function SearchBoxIsEmpty: Boolean;
    function SearchSuccessForProject(const aProjectFile, aModifiedStr: string): Boolean;
    procedure SetBtnGroupIconGrouped;
    procedure SetExternalEditor;
    procedure SetLabelUIFontSize;
    procedure UncheckAllpmGroupMenuItems;
    procedure SetShellIcons;
    procedure TryDoCheckedGrouping;
    procedure ButtonSetIdealSize(AButton: TButton);
    function CheckInput(const aNewFolderName: string; out aNewPrompt: string; const aPurpose: string): Boolean;
    procedure DoAppendGroupNodesInformation;
    procedure DoCreateGroupLink(const aProjectFilePath, aTargetLinkFile: string);
    procedure DoInitializeProjectGroups;
    function SourcetextContainsAllSearchWords(const aSourceText: string; aSearchWordsList: TStringList): Boolean;
    procedure DoReloadOriginalNotesFile;
    procedure FillListBoxWithSourceFiles(const aProjectText: string; aSearchWordsList: TStringList = nil);
    function GetFirstSearchboxWord: string;
    function GetNotesFilePath(const aProject: string): string;
    function GetProjectPath(const aProject: string): string;
    procedure InitializeProjectFilesList(Sender: TObject);
    procedure ShowOrHideNotesIndicator(aShow: Boolean);
    function GetListOfFilterSearchWords: TStringList;
    function GetListOfSourceFilesForProject(const aProject, aProjectPath: string): TStringList;
    function GetNewFilePathVersion(const aFilePath: string): string;
    function GetTargetFileFromLinkFile(const aLinkFilePath: string): string;
    function IsExistingProjectFileInClipboard: Boolean;
    function IsExistingProjectFilePathTextInClipboard: Boolean;
    procedure TryAddThisSourceFileToSearchResults(const aListItem: string; aSearchWordsList: TStringList);
    procedure TryCopySelectedProjectFilePath;
    function MyGetNodeFromNodeIndex(const aIdx: Integer): TTreeNode;
    function NodeTextRemoveNumber(const aNodetext: string): string;
    function ClipboardGetAsFile: string;
    procedure DoListTheProjectsFromSelectedProjectGroup(NotClearProjectList: Boolean = False);
    procedure DoSetCustomTitleBarColors(const aColor: TColor);
    procedure DoShowAboutCard;
    procedure DoShowGroupProjects(aTreeNode: TTreeNode);
    procedure DoTogglePreferences;
    procedure DoUpdateGroupsControl;
    function NodeFolderContainsLinkToSelectedProject(aNode: TTreeNode): Boolean;
    function ProjectsStr: string;
    procedure ResetOldGroupSelection(const aOldFullPath: string);
    procedure SetProjectListGroupMode(aGroupMode: Boolean);
    function GetBuildInfoAsString: string;
    procedure ResetGroupsFonts;
    procedure AdjustMyTitleBarControls(const aColor: TColor);
    procedure BuildOpenInIDEMenu;
    procedure DoProcessParameters;
    procedure DoSearchProject(const aProjectFilePath: string);
    procedure ExtractAllBdsExePaths;
    procedure ExtractDelphiBdsPath(const aVersion: Integer);
    function GetBdsExePath(const verstr: string; var BdsExePath: string): Boolean;
    function GetDelphiVersionStr(const aVersionStr: string): string;
    function GetMainWindowHandleFromProcessPath(const aProcessPath: string): HWND;
    procedure MakeSelectedProjectListItemVisible;
    procedure SetAboutInfo;
    procedure SetModifiedColumnToIdealWidth;
    procedure SetSpecialControls;
    procedure WorkaroundToRealignColumnWidths;
    procedure ResetTitleBarColors;
    procedure SetProjectListModeCaption(const aCaption: string);
    procedure SetSelectedProjectListMode;
    procedure SetStayOnTopPushPinToNormal;
    procedure ShowModeSelectionDropdownMenu;
    procedure ShowProjectListCountInHeader(const aString: string);
    procedure ShowPropertiesDialog(const FileName: string);
    procedure StartOrActivateIDEClick(Sender: TObject);
    function ProcessExists(const exeFileName: string): Boolean;
    procedure SetCheckedStatusOfLaunchIDEMenuItems;
    procedure SetHintProperties;
    procedure SetSearchBoxEmptyText(const aEmptyText: string);
  public

  end;

var
  formMain: TformMain;

implementation

uses
  USigned,
  Winapi.ShellAPI, Winapi.ActiveX, Winapi.CommCtrl, Winapi.ShLwApi, Winapi.PsAPI, Winapi.TlHelp32,
  System.Win.Registry, System.Win.ComObj,
  System.IniFiles, System.RegularExpressions, System.StrUtils, System.IOUtils, System.Generics.Collections, System.Math,
  Vcl.OleAuto, Vcl.Clipbrd,
  RzShellUtils, RzCommon;

{$R *.dfm}

procedure PALockWinControl(const WC: Vcl.Controls.TWinControl; ALock: Boolean);
begin
  if (not Assigned(WC)) or (WC.Handle = 0) then EXIT;

  if ALock then
    WC.Perform(WM_SETREDRAW, 0, 0)
  else
  begin
    WC.Perform(WM_SETREDRAW, 1, 0);
    RedrawWindow(WC.Handle, nil, 0, RDW_ERASE or RDW_FRAME or RDW_INVALIDATE or RDW_ALLCHILDREN);
  end;
end;

procedure TListView.CreateWnd;
begin
  inherited;
  FHeaderHandle := ListView_GetHeader(Handle);
end;

procedure TListView.WMNotify(var AMessage: TWMNotify);
var
  FontColor: TColor;
  NMCustomDraw: TNMCustomDraw;
  hdn: ^THDNotify;
begin
  if (AMessage.NMHdr.hwndFrom = FHeaderHandle) and (AMessage.NMHdr.code = NM_CUSTOMDRAW) then
  begin
    NMCustomDraw := PNMCustomDraw(TMessage(AMessage).LParam)^;
    case NMCustomDraw.dwDrawStage of
      CDDS_PREPAINT:
        AMessage.Result := CDRF_NOTIFYITEMDRAW;
      CDDS_ITEMPREPAINT:
        begin
          FontColor := Font.Color;
          if Assigned(FOnGetHeaderItemFontColor) then
            FOnGetHeaderItemFontColor(Self, NMCustomDraw.dwItemSpec, FontColor);
          SetTextColor(NMCustomDraw.hdc, ColorToRGB(FontColor));
          AMessage.Result := CDRF_NEWFONT;
        end;
    else
      AMessage.Result := CDRF_DODEFAULT;
    end;
  end
  else
  begin
    inherited;
  end;
end;

procedure TListView.CNMeasureItem(var Message: TWMMeasureItem);
begin
  inherited;
  if formMain.chkCustomizeRowHeight.Checked then
    Message.MeasureItemStruct.itemHeight := formMain.nbRowheight.ValueInt;
end;

procedure TformMain.WMAfterShow(var Msg: TMessage);
begin
  if FTitleBarColor <> clNone then
  begin
    DoSetCustomTitleBarColors(FTitleBarColor);
  end;

  if searchboxProjectsList.CanFocus then
    Self.ActiveControl := searchboxProjectsList;

  WorkaroundToRealignColumnWidths;
end;

procedure TformMain.WMParameter(var Msg: TMessage);

var
  LMem: PChar;
  LDest: String;
begin
  var ThisFileHandle := CreateFileMapping($FFFFFFFF, nil, PAGE_READWRITE, 0, 500, 'Project');
  if ThisFileHandle <> 0 then
  begin
    LMem := MapViewOfFile(ThisFileHandle, FILE_MAP_WRITE, 0, 0, 0);
    System.SetLength(LDest, Length(LMem));
    System.SysUtils.StrCopy(PChar(LDest), LMem);
    Winapi.Windows.UnmapViewOfFile(LMem);
    DoSearchProject(LDest);
    Winapi.Windows.CloseHandle(ThisFileHandle);
  end;
end;

procedure TformMain.WorkaroundToRealignColumnWidths;
begin
  Self.Width := Self.Width + 1;
  Self.Width := Self.Width - 1;
end;

procedure TformMain.SaveWindowPlacementAndPreferences;
var
  State: Integer;
  Pl : TWindowPlacement;
  R: TRect;
begin
  Pl.Length := SizeOf(TWindowPlacement);
  GetWindowPlacement(Self.Handle, @Pl);
  R := Pl.rcNormalPosition;
  var PersistIniFile := TIniFile.Create(FSettingsFile);
  try
    with PersistIniFile do
    begin
      WriteInteger('Placement', 'Width',  R.Right-R.Left);
      WriteInteger('Placement', 'Height', R.Bottom-R.Top);
      WriteInteger('Placement', 'Left',   R.Left);
      WriteInteger('Placement', 'Top',    R.Top);
      if IsIconic(Application.Handle) then
        State := Ord(wsMinimized)
      else
        State := Ord(Self.WindowState);
      WriteInteger('Placement', 'State', State);

      WriteInteger('Controls', 'UIFontSize', Self.Font.Size);
      WriteInteger('Controls', 'ProjectDetailsWidth', CardPanelProjectDetails.Width);
      WriteInteger('Controls', 'SearchBoxWidth', searchboxProjectsList.Width);
      WriteInteger('Controls', 'GroupPanelWidth', pnlProjectGroups.Width);

      WriteInteger('Controls', 'CaptionColumnWidth', lvMRUProjects.Columns[0].Width);
      WriteInteger('Controls', 'ModifiedColumnWidth', lvMRUProjects.Columns[1].Width);
      WriteInteger('Controls', 'RowHeight', nbRowheight.ValueInt);
      WriteInteger('Preferences', 'TitleBarColor', Self.CustomTitleBar.BackgroundColor);

      WriteBool('Preferences', 'CustomizeTitleBarColor', chkCustomizeTitleBarColor.Checked);
      WriteBool('Preferences', 'CustomizeRowHeight', chkCustomizeRowHeight.Checked);
      WriteBool('Preferences', 'ReadAllMRUAtProgramStart',    chkReadAllMRUAtProgramStart.Checked);
      WriteBool('Preferences', 'HideNonExistingProjectFiles', chkHideNonExistingProjectFiles.Checked);
      WriteBool('Preferences', 'ShowAlternatingRowShadows',   chkShowAlternatingRowShadows.Checked);
      WriteString('Preferences', 'ExternalSourceEditor', edtExternalEditor.Text);

      WriteBool('Preferences', 'ShowInfoTips', chkShowInfoTips.Checked);
      WriteBool('Preferences', 'ShowHintsInStatusBar', chkShowHintsInStatusBar.Checked);
      WriteInteger('Preferences', 'HintHidePause', nbHintHidePause.ValueInt);
    end;
  finally
    PersistIniFile.Free;
  end;
end;

procedure TformMain.RestoreWindowPlacementAndPreferences;
var
  StoredTitleBarColor: TColor;
begin
  if not FileExists(FSettingsFile) then EXIT;
  Self.Position := poDefault;
  var PersistIniFile := TIniFile.Create(FSettingsFile);
  try
    with PersistIniFile do
    begin
      Self.Width  := ReadInteger('Placement', 'Width',  Self.Width);
      Self.Height := ReadInteger('Placement', 'Height', Self.Height);
      Self.Left   := ReadInteger('Placement', 'Left',   Self.Left);
      Self.Top    := ReadInteger('Placement', 'Top',    Self.Top);
      var State := ReadInteger('Placement', 'State', Ord(wsNormal));
      if State = Ord(wsMinimized) then
      begin
        Self.Visible := True;
        Application.Minimize;
      end
      else
        Self.WindowState := TWindowState(State);

      Self.Font.Size := ReadInteger('Controls', 'UIFontSize', 10);
      CardPanelProjectDetails.Width := ReadInteger('Controls', 'ProjectDetailsWidth', 250);
      searchboxProjectsList.Width := ReadInteger('Controls', 'SearchBoxWidth', FDefaultSearchBoxWidth);
      pnlProjectGroups.Width := ReadInteger('Controls', 'GroupPanelWidth', 180);

      lvMRUProjects.Columns[0].Width := ReadInteger('Controls', 'CaptionColumnWidth', FDefaultCaptionColumnWidth);
      lvMRUProjects.Columns[1].Width := ReadInteger('Controls', 'ModifiedColumnWidth', FDefaultModifiedColumnWidth);
      nbRowheight.ValueInt := ReadInteger('Controls', 'RowHeight', 21);
      StoredTitleBarColor := ReadInteger('Preferences', 'TitleBarColor', Self.CustomTitleBar.BackgroundColor);

      chkCustomizeTitleBarColor.Checked := ReadBool('Preferences', 'CustomizeTitleBarColor', False);
      if chkCustomizeTitleBarColor.Checked then
      begin
        var ThisColor: TColor;
        ThisColor := TColor(StoredTitleBarColor);
        FTitleBarColor := ThisColor;
      end;
      chkCustomizeRowHeight.Checked := ReadBool('Preferences', 'CustomizeRowHeight', False);
      chkReadAllMRUAtProgramStart.Checked    := ReadBool('Preferences', 'ReadAllMRUAtProgramStart',    True);
      chkHideNonExistingProjectFiles.Checked := ReadBool('Preferences', 'HideNonExistingProjectFiles', False);
      EnableDisableHideNonExistingButton;
      chkShowAlternatingRowShadows.Checked   := ReadBool('Preferences', 'ShowAlternatingRowShadows',   True);
      edtExternalEditor.Text                 :=  ReadString('Preferences', 'ExternalSourceEditor', FDefaultExternalEditorFilepath);
      SetExternalEditor;

      chkShowInfoTips.Checked := ReadBool('Preferences', 'ShowInfoTips', True);
      chkShowHintsInStatusBar.Checked := ReadBool('Preferences', 'ShowHintsInStatusBar', True);
      nbHintHidePause.ValueInt := ReadInteger('Preferences', 'HintHidePause', 5);
      SetHintProperties;
    end;
  finally
    PersistIniFile.Free;
  end;
end;

procedure TformMain.SetHintProperties;
begin
  Self.ShowHint := chkShowInfoTips.Checked;
  Application.HintHidePause := nbHintHidePause.ValueInt * 1000;
end;

procedure GetBuildInfo(var V1, V2, V3, V4: word);
var
  VerInfoSize, VerValueSize, Dummy: DWORD;
  VerInfo: Pointer;
  VerValue: PVSFixedFileInfo;
begin
  VerInfoSize := Winapi.Windows.GetFileVersionInfoSize(PChar(ParamStr(0)), Dummy);
  if VerInfoSize > 0 then
  begin
    System.GetMem(VerInfo, VerInfoSize);
    try
      if Winapi.Windows.GetFileVersionInfo(PChar(ParamStr(0)), 0, VerInfoSize, VerInfo) then
      begin
        Winapi.Windows.VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
        with VerValue^ do
        begin
          V1 := dwFileVersionMS shr 16;
          V2 := dwFileVersionMS and $FFFF;
          V3 := dwFileVersionLS shr 16;
          V4 := dwFileVersionLS and $FFFF;
        end;
      end;
    finally
      System.FreeMem(VerInfo, VerInfoSize);
    end;
  end;
end;

function TformMain.GetBuildInfoAsString: string;
var
  V1, V2, V3, V4: word;
begin
  GetBuildInfo(V1, V2, V3, V4);
  Result := IntToStr(V1) + '.' + IntToStr(V2) + '.' + IntToStr(V3) + '.' + IntToStr(V4);
end;

procedure TformMain.SetExternalEditor;
begin
  FExternalEditorFilepath := Trim(edtExternalEditor.Text);
end;

function TformMain.GetDelphiMRUList(const verstr: string; MRUList: TStringList): Boolean;
begin
  var Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    Result := Reg.OpenKey('SOFTWARE\Embarcadero\BDS\' + verstr + '\Closed Projects', False);
    if Result then
    begin
      MRUList.Clear;
      var i := 0;
      while Reg.ValueExists('File_' + i.ToString) do
      begin
        MRUList.Add(Reg.ReadString('File_' + i.ToString));
        Inc(i);
      end;
    end;
  finally
    Reg.Free;
  end;
end;

function TformMain.GetBdsExePath(const verstr: string; var BdsExePath: string): Boolean;
begin
  var Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    Result := Reg.OpenKey('SOFTWARE\Embarcadero\BDS\' + verstr, False);
    if Result then
    begin
      if Reg.ValueExists('App') then
      begin
        var ThisBdsExePath := Reg.ReadString('App');
        if FileExists(ThisBdsExePath) then
          BdsExePath := ThisBdsExePath;
      end;
    end;
  finally
    Reg.Free;
  end;
end;

procedure TformMain.ExtractDelphiMRUList(const aVersion: Integer);
begin
  var List := TStringList.Create;
  try
    if GetDelphiMRUList(IntToStr(aVersion) + '.0', List) then
    begin
      var RegexObj: TRegEx;
      var MatchResult: TMatch;
      var SL: TStringList;
      SL := TStringList.Create;
      try
        RegexObj := TRegEx.Create('(?<=TBaseProject,'').*(?='')', [roIgnoreCase]);
        MatchResult := RegexObj.Match(List.Text);
        while MatchResult.Success do
        begin
          SL.Add(MatchResult.Value);
          MatchResult := MatchResult.NextMatch;
        end;
        FAllMRULists.AddPair(IntToStr(aVersion), SL.Text);
      finally
        SL.Free;
      end;
    end;
  finally
    List.Free;
  end;
end;

procedure TformMain.ExtractDelphiBdsPath(const aVersion: Integer);
begin
  var ThisBdsExePath: string;
  if GetBdsExePath(IntToStr(aVersion) + '.0', ThisBdsExePath) then
  begin
    if not ThisBdsExePath.IsEmpty then
      FAllBdsExePaths.AddPair(IntToStr(aVersion), ThisBdsExePath);
  end;
end;

procedure TformMain.ExtractAllMRULists;
begin
  for var i := 22 downto 8 do
    ExtractDelphiMRUList(i);
end;

procedure TformMain.ExtractAllBdsExePaths;
begin
  FAllBdsExePaths := TStringList.Create;
  for var i := 22 downto 8 do
    ExtractDelphiBdsPath(i);

  BuildOpenInIDEMenu;
end;

procedure TformMain.BuildOpenInIDEMenu;
begin
  if FAllBdsExePaths.Count = 0 then
  begin
    menuitemNoDelphiAppsFound.Visible := True;
    EXIT;
  end;

  for var i := 0 to FAllBdsExePaths.Count - 1 do
  begin
    AddIDEMenuItem(StrToIntDef(FAllBdsExePaths.Names[i], 0), pmOpenInIDE);
  end;
end;

procedure TformMain.AddIDEMenuItems;
begin
  for var i := 0 to FAllMRULists.Count - 1 do
  begin
    AddIDEMenuItem(StrToIntDef(FAllMRULists.Names[i], 0), pmIDESelection);
  end;
end;

procedure TformMain.AddIDEMenuItem(const aVersion: Integer; aPopupMenu: TPopupMenu);
begin
  var IDEName: string;
  var ThisImageIndex: Integer;
  case aVersion of
    22: begin
          IDEName := 'Delphi 11 Alexandria';
          ThisImageIndex := 0;
        end;
    21: begin
          IDEName := 'Delphi 10.4 Sydney';
          ThisImageIndex := 1;
        end;
    20: begin
          IDEName := 'Delphi 10.3 Rio';
          ThisImageIndex := 2;
        end;
    19: begin
          IDEName := 'Delphi 10.2 Tokyo';
          ThisImageIndex := 3;
        end;
    18: begin
          IDEName := 'Delphi 10.1 Berlin';
          ThisImageIndex := 3;
        end;
    17: begin
          IDEName := 'Delphi 10 Seattle';
          ThisImageIndex := 3;
        end;
    16: begin
          IDEName := 'Delphi XE8';
          ThisImageIndex := 3;
        end;
    15: begin
          IDEName := 'Delphi XE7';
          ThisImageIndex := 3;
        end;
    14: begin
          IDEName := 'Delphi XE6';
          ThisImageIndex := 3;
        end;
    12: begin
          IDEName := 'Delphi XE5';
          ThisImageIndex := 3;
        end;
    11: begin
          IDEName := 'Delphi XE4';
          ThisImageIndex := 3;
        end;
    10: begin
          IDEName := 'Delphi XE3';
          ThisImageIndex := 3;
        end;
    9:  begin
          IDEName := 'Delphi XE2';
          ThisImageIndex := 3;
        end;
    8:  begin
          IDEName := 'Delphi XE';
          ThisImageIndex := 3;
        end;
  end;
  if IDEName.IsEmpty then EXIT;

  if aPopupMenu = pmIDESelection then
  begin
    var NewMenuItem := TmenuItem.Create(aPopupMenu);
    with NewMenuItem do
    begin
      Caption := IDEName;
      Hint := 'Load ' + IDEName + ' MRU Projects';
      Tag := aVersion;
      ImageIndex := ThisImageIndex;
      OnClick := menuitemSpecificIDEClick;
    end;
    aPopupMenu.Items.Add(NewMenuItem);
  end
  else if aPopupMenu = pmOpenInIDE then
  begin
    var NewMenuItem := TmenuItem.Create(aPopupMenu);
    with NewMenuItem do
    begin
      Caption := 'Start or activate ' + IDEName;
      var ThisBdsExeFilePath := FAllBdsExePaths.Values[IntToStr(aVersion)];
      Hint := ThisBdsExeFilePath;
      Tag := aVersion;
      ImageIndex := ThisImageIndex;
      OnClick := StartOrActivateIDEClick;
    end;
    aPopupMenu.Items.Add(NewMenuItem);
  end;
end;

function GetPathFromPID(const PID: cardinal): string;
var
  hProcess: THandle;
  path: array[0..MAX_PATH - 1] of char;
begin
  hProcess := OpenProcess(PROCESS_QUERY_INFORMATION or PROCESS_VM_READ, false, PID);
  if hProcess <> 0 then
  try
    if GetModuleFileNameEx(hProcess, 0, path, MAX_PATH) = 0 then
      RaiseLastOSError;
    Result := path;
  finally
    CloseHandle(hProcess)
  end
  else
    RaiseLastOSError;
end;

type
  TFindWindowRec = record
  ModuleToFind: string;
  FoundHWnd: HWND;
end;

function PathsAreSamePIDL(const Path1, Path2: string): Boolean;
begin
  var AIL1: PItemIdList;
  var AIL2: PItemIdList;
  RzShellUtils.ShellGetIdListFromPath(Path1, AIL1);
  RzShellUtils.ShellGetIdListFromPath(Path2, AIL2);
  var CompResult:= RzShellUtils.CompareAbsIdLists(AIL1, AIL2);
  Result := CompResult = 0;
end;

function EnumWindowsCallBack(aHandle: HWND; var FindWindowRec: TFindWindowRec): BOOL; stdcall;
const
  C_FileNameLength = MAX_PATH;
  PROCESS_QUERY_LIMITED_INFORMATION = $1000;
var
  WinFileName: string;
  PID, hProcess: DWORD;
  Len: Byte;
begin
  Result := True;

  SetLength(WinFileName, C_FileNameLength);
  GetWindowThreadProcessId(aHandle, PID);
  hProcess := OpenProcess(PROCESS_QUERY_LIMITED_INFORMATION, False, PID);
  Len := GetModuleFileNameEx(hProcess, 0, PChar(WinFileName), C_FileNameLength);
  CloseHandle(hProcess);
  if Len > 0 then
  begin
    SetLength(WinFileName, Len);
    if PathsAreSamePIDL(WinFileName, FindWindowRec.ModuleToFind) then
    begin
      var IsVisible := IsWindowVisible(aHandle);
      if not IsVisible then EXIT;
      var IsOwned := GetWindow(aHandle, GW_OWNER) <> 0;
      if IsOwned then EXIT;
      var IsAppWindow := GetWindowLongPtr(aHandle, GWL_EXSTYLE) and WS_EX_APPWINDOW <> 0;
      if not IsAppWindow then EXIT;

      Result := False;
      FindWindowRec.FoundHWnd := aHandle;
    end;
  end;
end;

function TformMain.GetMainWindowHandleFromProcessPath(const aProcessPath: string): HWND;
var
  FindWindowRec: TFindWindowRec;
begin
  Result := 0;
  FindWindowRec.ModuleToFind := aProcessPath;
  FindWindowRec.FoundHWnd := 0;
  EnumWindows(@EnumWindowsCallback, LPARAM(@FindWindowRec));
  if FindWindowRec.FoundHWnd <> 0 then
  begin
    Result := FindWindowRec.FoundHWnd;
  end;
end;

function TformMain.ProcessExists(const exeFileName: string): Boolean;
var
  ContinueLoop: Winapi.Windows.BOOL;
  FSnapshotHandle: Winapi.Windows.THandle;
  FProcessEntry32: Winapi.TlHelp32.TProcessEntry32;
begin
  FSnapshotHandle := Winapi.TlHelp32.CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  FProcessEntry32.dwSize := System.SizeOf(FProcessEntry32);
  ContinueLoop := Winapi.TlHelp32.Process32First(FSnapshotHandle, FProcessEntry32);
  Result := False;
  var ThisExeName := ExtractFileName(exeFileName);
  while Integer(ContinueLoop) <> 0 do
  begin
    if SameText(ExtractFileName(FProcessEntry32.szExeFile), ThisExeName) or SameText(FProcessEntry32.szExeFile, ThisExeName) then
    begin
      var ThisBdsExePath := GetPathFromPID(FProcessEntry32.th32ProcessID);
      Result := PathsAreSamePIDL(exeFileName, ThisBdsExePath);
      if Result then
      begin
        var ThisWindowHandle := GetMainWindowHandleFromProcessPath(ThisBdsExePath);
        BREAK;
      end;
    end;
    ContinueLoop := Process32Next(FSnapshotHandle, FProcessEntry32);
  end;
  Winapi.Windows.CloseHandle(FSnapshotHandle);
end;

procedure TformMain.StartOrActivateIDEClick(Sender: TObject);
begin
  var ThisBdsExePath := TMenuItem(Sender).Hint;
  if FileExists(ThisBdsExePath) then
  begin
    var IsCheckedRunning := TMenuItem(Sender).Checked;
    if IsCheckedRunning then
    begin
      var ThisHandle := GetMainWindowHandleFromProcessPath(ThisBdsExePath);
      SetForegroundWindow(ThisHandle);
    end
    else
    begin
      Winapi.ShellAPI.ShellExecute(0, 'Open', PChar(ThisBdsExePath), nil, nil, SW_SHOWNORMAL);
    end;
  end;
end;

procedure TformMain.menuitemALLDelphiMRUProjectsClick(Sender: TObject);
begin
  SetProjectListGroupMode(False);
  LoadAllMRUProjectsFromAllIIDEs(Sender);
  UncheckAllpmGroupMenuItems;
  FClickedMenuItem := menuitemALLDelphiMRUProjects;
  CardPanelProjectDetails.ActiveCard := cardNoProjectSelected;
  if Self.Visible then
  begin
    if lvMRUProjects.CanFocus then
      lvMRUProjects.SetFocus;
  end;
end;

procedure TformMain.AppEventsMainHint(Sender: TObject);
begin
  if Application.Hint <> '' then
  begin
    if chkShowHintsInStatusBar.Checked then
      StatusBarMain.SimpleText := Application.Hint;
  end
  else
    StatusBarMain.SimpleText := FOldHint;
end;

procedure TformMain.btnClosePreferencesClick(Sender: TObject);
begin
  CardPanelMain.ActiveCard := cardMain;
end;

procedure TformMain.btnCopyPathClick(Sender: TObject);
begin
  TryCopySelectedProjectFilePath;
end;

procedure TformMain.TryCopySelectedProjectFilePath;
begin
  if lvMRUProjects.SelCount = 1 then
  begin
    if FileExists(lvMRUProjects.Selected.Caption) then
      Clipboard.AsText := lvMRUProjects.Selected.Caption
    else
      Application.MessageBox('This Project file does not exist anymore.', PChar(Self.Caption), MB_OK + MB_ICONWARNING + MB_TOPMOST);
  end;
end;

procedure TformMain.btnEmptySearchBoxClick(Sender: TObject);
begin
  searchboxProjectsList.Text := '';
end;

procedure TformMain.btnOpenSelectedProjectClick(Sender: TObject);
var
  Pt: Winapi.Windows.TPoint;
begin
  Pt.X := btnOpenSelectedProject.Left;
  Pt.Y := btnOpenSelectedProject.Top + btnOpenSelectedProject.Height;
  Pt := btnOpenSelectedProject.Parent.ClientToScreen(Pt);
  pmOpenInIDE.Popup(Pt.X, Pt.Y);
end;

procedure TformMain.btnOpenSelInExplorerClick(Sender: TObject);
begin
  if lvMRUProjects.SelCount = 1 then
  begin
    if FileExists(lvMRUProjects.Selected.Caption) then
      Winapi.ShellAPI.ShellExecute(0, nil, 'explorer.exe', PChar('/select,' + lvMRUProjects.Selected.Caption), nil, SW_SHOWNORMAL)
    else
      Application.MessageBox('This Project file does not exist anymore.', PChar(Self.Caption), MB_OK + MB_ICONWARNING + MB_TOPMOST);
  end;
end;

procedure TformMain.btnTempHideNonExistingFilesClick(Sender: TObject);
begin
  DoHideNonExistingProjectFiles;
end;

procedure TformMain.DoHideNonExistingProjectFiles;
begin
  if btnTempHideNonExistingFiles.Down then
    btnTempHideNonExistingFiles.ImageIndex := 5
  else
    btnTempHideNonExistingFiles.ImageIndex := 4;

  lvMRUProjects.Items.BeginUpdate;
  try
    var SearchBoxText := searchboxProjectsList.Text;
    var GroupMenuItem: TmenuItem;
    if lvMRUProjects.GroupView then
    begin
      if lvMRUProjects.Items[0].GroupID in [1..3] then
        GroupMenuItem := menuitemByYear
      else if lvMRUProjects.Items[0].GroupID in [4..5] then
        GroupMenuItem := menuitemGroupByNotes
      else if  menuitemGroupByAppType.Checked then
        GroupMenuItem := menuitemGroupByAppType
      else if  menuitemGroupByFrameworkType.Checked then
        GroupMenuItem := menuitemGroupByFrameworkType;
    end;

    ReClickClickedmenuItem;
    if SearchBoxText <> '' then
    begin
      searchboxProjectsList.Text := SearchBoxText;
      Self.ActiveControl := nil;
    end
    else
    begin
      if Assigned(GroupMenuItem) then
        GroupMenuItem.Click;
    end;
  finally
    lvMRUProjects.Items.EndUpdate;
  end;
end;

procedure TformMain.ReClickClickedmenuItem;
begin
  if Assigned(FClickedMenuItem) then
    FClickedMenuItem.Click;
end;

procedure TformMain.chkHideNonExistingProjectFilesClick(Sender: TObject);
begin
  EnableDisableHideNonExistingButton;

  if Self.Visible then
    ReClickClickedmenuItem;
end;

procedure TformMain.DropFileSourceMainGetDragImage(Sender: TObject; const DragSourceHelper: IDragSourceHelper; var Handled: Boolean);
var
  Pt: Winapi.Windows.TPoint;
begin
  GetCursorPos(Pt);
  if Assigned(FWinControlToDrag) then
    Handled := Succeeded(DragSourceHelper.InitializeFromWindow(FWinControlToDrag.Handle, Pt, DropSource.TCustomDropSource(Sender) as Winapi.ActiveX.IDataObject));
end;

procedure TformMain.LoadAllMRUProjectsFromAllIIDEs(Sender: TObject);
begin
  if not chkReadAllMRUAtProgramStart.Checked then
  begin
    if not FAfterProgramStart then
    begin
      FAfterProgramStart := True;
      imgHeader.Visible := False;
      EXIT;
    end;
  end;

  imgHeader.Visible := True;

  var TempProjects := TStringList.Create;
  var TempProjects2 := TStringList.Create;
  try
    TempProjects.Sorted := True;
    TempProjects.Duplicates := dupIgnore;
    lvMRUProjects.Items.BeginUpdate;
    try
      lvMRUProjects.Clear;
      for var i := 0 to FAllMRULists.Count - 1 do
      begin
        TempProjects2.Text := FAllMRULists.ValueFromIndex[i];
        TempProjects.AddStrings(TempProjects2);
      end;
      for var j := 0 to TempProjects.Count - 1 do
      begin
        var ThisFileExists := FileExists(TempProjects[j]);
        if not ThisFileExists then
        begin
          if chkHideNonExistingProjectFiles.Checked or btnTempHideNonExistingFiles.Down then
            CONTINUE;
        end;
        with lvMRUProjects.Items.Add do
        begin
          Caption := TempProjects[j];
          if ThisFileExists then
          begin
            SubItems.Add(GetModifiedDateStr(TempProjects[j]));
            ImageIndex := 3;
          end
          else
          begin
            SubItems.Add(UNKNOWNSTR);
            ImageIndex := 4;
          end;
        end;
      end;
    finally
      lvMRUProjects.Items.EndUpdate;
    end;
  finally
    TempProjects2.Free;
    TempProjects.Free;
  end;
  SetHeader(3, TMenuItem(Sender).Caption);
  NewListInit;
  if FOldSortedColumn <> -1 then
    DoColumnSort(lvMRUProjects, FSortedColumn, False);

  ResetGroupsFonts;
end;

procedure TformMain.SetHeader(const aIconIdx: Integer; const aHeaderCaption: string);
begin
  ilHeader.GetIcon(aIconIdx, imgHeader.Picture.Icon);
  lblheaderCaption.Caption := ' ' + aHeaderCaption + ' ';
end;

procedure TformMain.menuitemSpecificIDEClick(Sender: TObject);
begin
  SetProjectListGroupMode(False);

  imgHeader.Visible := True;
  var ThisVersion := TMenuItem(Sender).Tag;
  var ThisImageIndex := TMenuItem(Sender).ImageIndex;
  var ThisSpecMRUListIndex := FAllMRULists.IndexOfName(IntToStr(ThisVersion));
  if ThisSpecMRUListIndex > -1 then
  begin
    var ThisProjectList := TStringList.Create;
    try
      ThisProjectList.Text := FAllMRULists.ValueFromIndex[ThisSpecMRUListIndex];

      lvMRUProjects.Items.BeginUpdate;
      try
        lvMRUProjects.Clear;
        for var i := 0 to ThisProjectList.Count - 1 do
        begin
          var ThisFileExists := FileExists(ThisProjectList[i]);
          if not ThisFileExists then
          begin
            if chkHideNonExistingProjectFiles.Checked or btnTempHideNonExistingFiles.Down then
              CONTINUE;
          end;
          with lvMRUProjects.Items.Add do
          begin
            Caption := ThisProjectList[i];
            if ThisFileExists then
            begin
              SubItems.Add(GetModifiedDateStr(ThisProjectList[i]));
              ImageIndex := ThisImageIndex;
            end
            else
            begin
              SubItems.Add(UNKNOWNSTR);
              ImageIndex := 4;
            end;
          end;
        end;
      finally
        lvMRUProjects.Items.EndUpdate;
      end;

    finally
      ThisProjectList.Free;
    end;
    SetHeader(ThisImageIndex, TMenuItem(Sender).Caption);
    NewListInit;
    if FOldSortedColumn <> -1 then
      DoColumnSort(lvMRUProjects, FSortedColumn, False);
    FClickedMenuItem := TMenuItem(Sender);
  end;

  UncheckAllpmGroupMenuItems;

  ResetGroupsFonts;

  CardPanelProjectDetails.ActiveCard := cardNoProjectSelected;

  if lvMRUProjects.CanFocus then
    lvMRUProjects.SetFocus;
end;

procedure TformMain.NewListInit;
begin
  tlbProjectsList.Enabled := True;
  searchboxProjectsList.Text := '';
  lvMRUProjects.GroupView := False;
  EnableDisableActions(False);
  ShowUnfilteredStatus;
  if lvMRUProjects.Items.Count > 0 then
  begin
    EnableDisableHideNonExistingButton;
  end;
  btnShowDetailsPane.Enabled := True;
  btnShowDetailsPane.Down := True;
end;

procedure TformMain.EnableDisableHideNonExistingButton;
begin
  btnTempHideNonExistingFiles.Enabled := not chkHideNonExistingProjectFiles.Checked;
  btnTempHideNonExistingFiles.Visible := not chkHideNonExistingProjectFiles.Checked;
end;

procedure TformMain.EnableDisableActions(const Enable: Boolean);
begin
  btnOpenSelInExplorer.Enabled := Enable;
  btnCopyPath.Enabled := Enable;
  btnLoadSelectedProjectInExternalEditor.Enabled := Enable;
end;

procedure TformMain.ShowUnfilteredStatus;
begin
  ShowProjectListCountInHeader(IntToStr(lvMRUProjects.Items.Count) + ProjectsStr);
end;

procedure TformMain.ShowTextInStatusBar(const aText: string);
begin
  StatusBarMain.SimpleText := aText;
  FOldHint := aText;
end;

procedure TformMain.SetShellIcons;
var
  FileInfo: Winapi.ShellAPI.SHFILEINFO;
  NewIcon: TIcon;
  function GetFileInfo(const aExt: string): Integer;
  begin
    Winapi.ShellAPI.SHGetFileInfo(PChar(aExt), FILE_ATTRIBUTE_NORMAL, FileInfo, SizeOf(FileInfo), SHGFI_ICON or SHGFI_SMALLICON or SHGFI_SYSICONINDEX or SHGFI_USEFILEATTRIBUTES);
    NewIcon.Handle := FileInfo.hIcon;
    Result := formMain.ilShellIcons.AddIcon(NewIcon);
  end;
begin
  NewIcon := TIcon.Create;
  try
    FIconIdx_DPR := GetFileInfo('*.dpr');
    FIconIdx_PAS := GetFileInfo('*.pas');
    FIconIdx_DFM := GetFileInfo('*.dfm');
    FIconIdx_TXT := GetFileInfo('*.txt');
    FIconIdx_DPK := GetFileInfo('*.dpk');
    FIconIdx_DCR := GetFileInfo('*.dcr');
    FIconIdx_EXE := GetFileInfo('*.exe');
  finally
    DestroyIcon(FileInfo.hIcon);
    NewIcon.Free;
  end;
end;

procedure TformMain.DoSearchProject(const aProjectFilePath: string);
begin
  var ThisProjectFilePath := aProjectFilePath;
  if SameText(ExtractFileExt(ThisProjectFilePath), '.DPROJ') then
  begin
    if FileExists(ThisProjectFilePath) then
    begin
      var Node: TTreeNode;
      var ThisNodeFullPath: string;
      var TargetFileOfExistingLink: string;
      var LList: System.Types.TStringDynArray;

      var ParameterProjectFound: Boolean := False;
      for var n := 0 to RzShellTreeGroups.Items.Count - 1 do
      begin
        Node := RzShellTreeGroups.Items[n];
        ThisNodeFullPath := (RzShellTreeGroups.GetDataFromNode(Node)).PathName;
        if System.SysUtils.DirectoryExists(ThisNodeFullPath) then
        begin
          LList := TDirectory.GetFiles(ThisNodeFullPath, '*.LNK', TSearchOption.soTopDirectoryOnly);

          for var i := 0 to Length(LList) - 1 do
          begin
            TargetFileOfExistingLink := GetTargetFileFromLinkFile(LList[i]);
            if Fileexists(TargetFileOfExistingLink) then
            begin
              if SameText(ThisProjectFilePath, TargetFileOfExistingLink) then
              begin
                Node.Selected := True;
                DoShowGroupProjects(RzShellTreeGroups.Selected);

                for var p := 0 to lvMRUProjects.Items.Count - 1 do
                begin
                  if SameText(ThisProjectFilePath, lvMRUProjects.Items[p].Caption) then
                  begin
                    lvMRUProjects.Items[p].Selected := True;
                    ParameterProjectFound := True;
                    MakeSelectedProjectListItemVisible;
                    BREAK;
                  end;
                end;
                if ParameterProjectFound then BREAK;
              end;
            end;
          end;
        end;
        if ParameterProjectFound then BREAK;
      end;

      if not ParameterProjectFound then
      begin

        for var a := 0 to FAllMRULists.Count - 1 do
        begin
          if ContainsText(FAllMRULists[a], ThisProjectFilePath) then
          begin
            lvMRUProjects.Items.BeginUpdate;
            try
              menuitemALLDelphiMRUProjects.Click;
              for var p := 0 to lvMRUProjects.Items.Count - 1 do
              begin
                if SameText(ThisProjectFilePath, lvMRUProjects.Items[p].Caption) then
                begin
                  lvMRUProjects.Items[p].Selected := True;
                  ParameterProjectFound := True;
                  MakeSelectedProjectListItemVisible;
                  BREAK;
                end;
              end;
            finally
              lvMRUProjects.Items.EndUpdate;
            end;
            BREAK;
          end;
        end;
      end;

      if not ParameterProjectFound then
      begin
        if MessageBoxW(Handle, PChar(ExtractFileName(ThisProjectFilePath) + ' was not found in any Project-Group nor any MRU-List.' + #13#10#13#10 +
          'Do you want to show it in the Project-List so that you can add it to a Group?'), PWideChar(Application.Title), MB_OKCANCEL + MB_ICONQUESTION + MB_TOPMOST) = IDOK then
        begin

          Screen.Cursor := crHourGlass;
          try
            lvMRUProjects.Items.BeginUpdate;
            try
              lvMRUProjects.Clear;
              with lvMRUProjects.Items.Add do
              begin
                Caption := ThisProjectFilePath;
                if FileExists(ThisProjectFilePath) then
                begin
                  SubItems.Add(GetModifiedDateStr(ThisProjectFilePath));
                  ImageIndex := 6;
                end
                else
                begin
                  SubItems.Add(UNKNOWNSTR);
                  ImageIndex := 4;
                end;
                Selected := True;
                ShowProjectListCountInHeader('1 imported new Project');
              end;
            finally
              lvMRUProjects.Items.EndUpdate;
            end;
          finally
            Screen.Cursor := crDefault;
          end;

        end;
      end;
    end
    else
    begin
      MessageBoxW(Handle, 'This Delphi Project file does not exist.', PWideChar(Application.Title), MB_OK + MB_ICONINFORMATION + MB_TOPMOST);
    end;
  end
  else
  begin
    MessageBoxW(Handle, 'This is not a DPROJ (Delphi Project) file-path.', PWideChar(Application.Title), MB_OK + MB_ICONINFORMATION + MB_TOPMOST);
  end;
end;

procedure TformMain.DoProcessParameters;
begin
  if FindCmdLineSwitch('IDE') then
  begin
    if ParamCount = 2 then
    begin
      var ThisProjectFilePath := ParamStr(2);
      DoSearchProject(ThisProjectFilePath);
    end;
  end
  else
  begin
    if ParamCount = 1 then
    begin
      var ThisProjectFilePath := ParamStr(1);
      DoSearchProject(ThisProjectFilePath);
    end;
  end;
end;

procedure TformMain.MakeSelectedProjectListItemVisible;
begin
  var SelItem := lvMRUProjects.Selected;
   if Assigned(SelItem) then
   begin
     var R := SelItem.DisplayRect(drBounds);
     lvMRUProjects.Scroll(0, R.Top - lvMRUProjects.ClientHeight div 2);
   end;
end;

procedure TformMain.FormCreate(Sender: TObject);
begin
  Application.Title := 'Delphi MRU Project Manager';
  CF_FILE := RegisterClipboardFormat('FileNameW');

  FListOfSourceFilesContainingSearchWords := TStringList.Create;
  FListOfSourceFilesContainingSearchWords.Sorted := True;
  FListOfSourceFilesContainingSearchWords.Duplicates := dupIgnore;

  FtsNotesCaption := tsNotes.Caption;

  FDefaultSearchBoxWidth := searchboxProjectsList.Width;

  FDefaultCaptionColumnWidth  := lvMRUProjects.Columns[0].Width;
  FDefaultModifiedColumnWidth := lvMRUProjects.Columns[1].Width;

  SetShellIcons;

  FDefaultExternalEditorFilepath := edtExternalEditor.Text;

  FSortedColumn := -1;
  FOldSortedColumn := -1;

  FApplDir := System.SysUtils.IncludeTrailingPathDelimiter(ExtractFilePath(Application.ExeName));
  FSettingsFile := FApplDir + 'Settings.ini';

  FTitleBarColor := clNone;
  RestoreWindowPlacementAndPreferences;

  FAllMRULists := TStringList.Create;
  FExePairList := TStringList.Create;

  ExtractAllMRULists;
  ExtractAllBdsExePaths;

  AddIDEMenuItems;

  menuitemALLDelphiMRUProjects.Click;
  FClickedMenuItem := menuitemALLDelphiMRUProjects;
  SetProjectListGroupMode(False);

  CardPanelMain.ActiveCard := cardMain;
  CardPanelProjectDetails .ActiveCard := cardNoProjectSelected;
  pgcProjectDetails.ActivePageIndex := 0;

  lvMRUProjects.OnGetHeaderItemFontColor := GetHeaderItemFontColor;

  SetColumnHeaderFontBold;

  menuitemIncreaseFontSize.Shortcut := scShift + scAlt + VK_OEM_PLUS;
  menuitemDecreaseFontSize.Shortcut := scShift + scAlt + VK_OEM_MINUS;
  menuitemFont.Shortcut := scShift + scCtrl + 70;
  FormatRichEditBulletsCmd.Shortcut := scShift + scCtrl + 66;
  menuitemZoomIN.Shortcut      := scCtrl + VK_ADD;
  menuitemZoomOUT.Shortcut     := scCtrl + VK_SUBTRACT;
  menuitemZoomDEFAULT.Shortcut := scCtrl + VK_NUMPAD0;
  menuitemAlignLeft.Shortcut   := scCtrl + VK_NUMPAD4;
  menuitemAlignCenter.Shortcut := scCtrl + VK_NUMPAD5;
  menuitemAlignRight.Shortcut  := scCtrl + VK_NUMPAD6;
  menuitemColorForeground.Shortcut  := scCtrl + scShift + scAlt + 70;
  menuitemColorBackground.Shortcut  := scCtrl + scShift + scAlt + 66;
  menuitemIndentIncrease.ShortCut := scCtrl + scShift +  VK_RIGHT;
  menuitemIndentDecrease.ShortCut := scCtrl + scShift +  VK_LEFT;
  menuitemCycleThroughDifferentBulletStyles.Caption := menuitemCycleThroughDifferentBulletStyles.Caption + #9 + '    Shift+Ctrl+L';
  menuitemPastePlainText.Shortcut  := scCtrl + scShift + 86;

  SetLabelUIFontSize;

  il20.GetIcon(0, imgProjectDetails.Picture.Icon);

  btnFilterProjectFilePath.Enabled := True;
  btnFilterProjectFilePath.Down := True;
  FOldFilterButton := btnFilterProjectFilePath;
  SetSearchBoxEmptyText(SEARCHBOXEMPTYTEXT_FilePaths);
  btnFilterNotes.Enabled := True;
  btnFilterNotes.Down := False;
  btnFilterSourceFiles.Enabled := True;
  btnFilterSourceFiles.Down := False;

  DoInitializeProjectGroups;

  Self.Caption := Self.Caption + ' ' + GetBuildInfoAsString;

  SetAboutInfo;

  SetSpecialControls;

  FPushPinImageIndex := 6;
  pnlTitleBarMenu.Color := Self.CustomTitleBar.BackgroundColor;

  DoProcessParameters;

  btnPasteProject.Enabled := True;
  btnOpenSelectedProject.Enabled := True;
end;

procedure TformMain.SetSearchBoxEmptyText(const aEmptyText: string);
begin
  searchboxProjectsList.TextHint := aEmptyText;
end;

procedure TformMain.SetAboutInfo;
begin

  if IsCodeSigned(ParamStr(0)) then
  begin

    ilCertificates.GetIcon(0, imgCertificateApplication.Picture.Icon);
    lblCertificateApplication.Caption := 'This Application IS digitally signed';
  end
  else
  begin

    ilCertificates.GetIcon(2, imgCertificateApplication.Picture.Icon);
    lblCertificateApplication.Caption := 'This Application is NOT digitally signed';
  end;

  if IsCompanySigningCertificate(ParamStr(0), 'PA-Soft e.U.') then
  begin

    ilCertificates.GetIcon(1, imgCertificateCompany.Picture.Icon);
    lblCertificateCompany.Caption := 'This Application IS digitally signed by PA-Soft e.U.';
  end
  else
  begin

    ilCertificates.GetIcon(3, imgCertificateCompany.Picture.Icon);
    lblCertificateCompany.Caption := 'This Application is NOT digitally signed by PA-Soft e.U.';
  end;

  RzVersionInfoMain.FilePath := '';
  if RzVersionInfoMain.VersionInfoAvailable then
  begin
    FCurrentProductVersion := RzVersionInfoMain.ProductVersion;
    lblAboutVersion.Caption :=
      'Company: PA-SOFT e.U. (Salzburg/Austria)'               + #13#10 +
      'Legal Copyright: PA-SOFT e.U.'                          + #13#10 +
      'Product Version: '  + RzVersionInfoMain.ProductVersion  + #13#10 +
      'File Version: '     + RzVersionInfoMain.FileVersion     + #13#10 +
      'Product Name: '     + RzVersionInfoMain.ProductName     + #13#10 +
      'Description: '      + RzVersionInfoMain.FileDescription + #13#10 +
      'Comments: '         + RzVersionInfoMain.Comments        + #13#10 +
      'Date: '             + FormatDateTime('YYYY-mm-dd', RzVersionInfoMain.FileDateTime);
  end
  else
    lblAboutVersion.Caption := 'Version Information not available.';

  lblAboutHomepage.Font.Color := clBlue;
  lblAboutHomepage.Font.Style := [TFontStyle.fsUnderline];
  lblAboutEmail.Font.Color := clBlue;
  lblAboutEmail.Font.Style := [TFontStyle.fsUnderline];
end;

procedure TformMain.DoInitializeProjectGroups;
var
  Node: TTreeNode;
begin
  FProjectGroupsPath := FApplDir + 'PROJECT-GROUPS\';

  System.SysUtils.ForceDirectories(FProjectGroupsPath + 'Favorites');

  RzShellTreeGroups.BaseFolder.PathName := FProjectGroupsPath;

  RzShellTreeGroups.FullExpand;

  DoAppendGroupNodesInformation;
end;

procedure TformMain.DoAppendGroupNodesInformation;
var
  Node: TTreeNode;
  LList: System.Types.TStringDynArray;
  ThisNodeRelativePath: string;
  ThisNodeFullPath: string;
begin
  RzShellTreeGroups.Items.BeginUpdate;
  try
    for var i := RzShellTreeGroups.Items.Count - 1 downto 1 do
    begin
      Node := RzShellTreeGroups.Items[i];
      ThisNodeFullPath := (RzShellTreeGroups.GetDataFromNode(Node)).PathName;
      if System.SysUtils.DirectoryExists(ThisNodeFullPath) then
      begin
        LList := TDirectory.GetFiles(ThisNodeFullPath, '*.LNK', TSearchOption.soTopDirectoryOnly);
        Node.Text := NodeTextRemoveNumber(Node.Text) + ' (' + IntToStr(Length(LList)) + ')';
      end;
    end;
  finally
    RzShellTreeGroups.Items.EndUpdate;
  end;
end;

function TformMain.NodeTextRemoveNumber(const aNodetext: string): string;
begin
  Result := TRegEx.Replace(aNodeText, '( \(\d+\))\z', '', [roIgnoreCase]);
end;

procedure TformMain.SetLabelUIFontSize;
begin
  lblUIFontSize.Caption := 'UI Font Size: ' + IntToStr(Self.Font.Size);
end;

procedure TformMain.GetHeaderItemFontColor(Sender: TCustomListView; ItemIndex: Integer; var FontColor: TColor);
begin
  if FSortedColumn <> -1 then
  begin
    if ItemIndex = FSortedColumn then
      FontColor := clRed;
  end;
end;

procedure TformMain.SetColumnHeaderFontBold;
var
  LF: Winapi.Windows.TLogFont;
  hheader: Winapi.Windows.HWND;
  hCurrFont: Winapi.Windows.HFONT;
begin
  hHeader := HWND(Winapi.Windows.SendMessage(lvMRUProjects.Handle, Winapi.CommCtrl.LVM_GETHEADER, 0, 0));
  hCurrFont := Winapi.Windows.HFONT(Winapi.Windows.SendMessage(hHeader, Winapi.Messages.WM_GETFONT, 0, 0));

  if GetObject(hCurrFont, SizeOf(LF), Addr(LF)) > 0 then
  begin
    var hOldFont: Winapi.Windows.HFONT;
    LF.lfWeight := Winapi.Windows.FW_BOLD;
    FhHeaderFont := Winapi.Windows.CreateFontIndirect(LF);
    hOldFont := Winapi.Windows.SelectObject(hHeader, FhHeaderFont);
    Winapi.Windows.SendMessage(hHeader, winapi.Messages.WM_SETFONT, WPARAM(FhHeaderFont), 1);
  end;
end;

procedure TformMain.FormDestroy(Sender: TObject);
begin
  FAllMRULists.Free;
  FExePairList.Free;
  FListOfSourceFilesContainingSearchWords.Free;
  FAllBdsExePaths.Free;
  SaveWindowPlacementAndPreferences;
  if FhHeaderFont > 0 then
    Winapi.Windows.DeleteObject(FhHeaderFont);
end;

procedure TformMain.lvMRUProjectsDblClick(Sender: TObject);
begin
  OpenSelectedProjectInExternalEditor;
end;

procedure TformMain.lvMRUProjectsSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
begin
  EnableDisableActions(Selected);
  if Selected then
  begin
    if btnFilterNotes.Down then
      pgcProjectDetails.ActivePage := tsNotes
    else if btnFilterSourceFiles.Down and (not SearchBoxIsEmpty) then
      pgcProjectDetails.ActivePage := tsFiles;

    ShowProjectDetails;

    if FProjectListGroupMode then
      btnRemoveSelProjectFromGroup.Enabled := True;
  end
  else
  begin
    if lvMRUProjects.ItemIndex = -1 then
    begin
      ClearProjectDetails;
      CardPanelProjectDetails.ActiveCard := cardNoProjectSelected;
      btnRemoveSelProjectFromGroup.Enabled := False;
    end;

      btnRemoveSelProjectFromGroup.Enabled := lvMRUProjects.SelCount <> 0;
  end;

  RzShellTreeGroups.Invalidate;

  if FProjectListGroupMode then
    btnRemoveSelProjectFromGroup.Enabled := lvMRUProjects.SelCount <> 0;
end;

procedure TformMain.ClearProjectDetails;
begin
  RichEditClearAll;
  lblAppType.Caption       := '';
  lblFrameworkType.Caption := '';
  lblCreatedDate.Caption   := '';
  lblLastAccessed.Caption  := '';
  listboxExeFiles.Clear;
  listboxProjectFiles.Clear;
  btnSaveRTF.Enabled := False;
end;

function TformMain.GetFileText(const aTextFile: string): string;
begin
  if not FileExists(aTextFile) then EXIT;

  var SL := TStringList.Create;
  try
    SL.LoadFromFile(aTextFile);
    Result := SL.Text;
  finally
    SL.Free;
  end;
end;

function TformMain.GetValueFromBetweenTags(const aText, aStartTag, aEndTag: string): string;
begin
  Result := System.RegularExpressions.TRegEx.Match(aText, '(?<=' + aStartTag + ').*(?=' + aEndTag + ')', [roIgnoreCase]).Value;
end;

function TformMain.GetSortedNoDuplicatesStringList: TStringList;
begin
  Result := TStringList.Create;
  Result.Sorted := True;
  Result.Duplicates := dupIgnore;
end;

function MyAbsToRel(const AbsPath, BasePath: string): string;
var
  Path: array[0..MAX_PATH-1] of char;
begin
  Winapi.ShLwApi.PathRelativePathTo(@Path[0], PChar(BasePath), FILE_ATTRIBUTE_DIRECTORY, PChar(AbsPath), 0);
  Result := Path;
end;

function MyRelToAbs(const RelPath, BasePath: string): string;
var
  Dst: array[0..MAX_PATH-1] of char;
begin
  PathCanonicalize(@Dst[0], PChar(IncludeTrailingBackslash(BasePath) + RelPath));
  Result := Dst;
end;

procedure TformMain.RichEditClearAll;
begin
  richeditNotesEditor.Lines.Clear;
  richeditNotesEditor.Paragraph.Numbering := nsNone;
  menuitemBullets.Checked := False;
  richeditNotesEditor.Paragraph.FirstIndent := 0;
  richeditNotesEditor.Paragraph.Alignment := taLeftJustify;
end;

procedure TformMain.ShowOrHideNotesIndicator(aShow: Boolean);
begin
  if aShow then
    tsNotes.Caption := FtsNotesCaption + '!'
  else
    tsNotes.Caption := FtsNotesCaption;
end;

procedure HighLightAllWordsInRichEdit(RE: TRichEdit; const aWord: string; aColor: TColor; aStyle: TFontStyles);
var
  i, CharPos, CharPos2, noChars: Integer;
begin
  CharPos := 0;
  noChars := 0;

  for i := 0 to Pred(RE.Lines.Count) do
    noChars := noChars + Length(RE.Lines[i]);
  repeat
    CharPos2 := RE.FindText(aWord, CharPos, noChars, []);
    CharPos := CharPos2 + 1;
    RE.SelStart := CharPos2;
    RE.SelLength := Length(aWord);
    RE.SelAttributes.BackColor := aColor;
    RE.SelAttributes.Style := aStyle;
  until CharPos = 0;
end;

function TformMain.GetListOfFilterSearchWords: TStringList;
begin
  Result := TStringList.Create;
  var SearchText := Trim(searchboxProjectsList.Text);
  while System.StrUtils.ContainsText(SearchText, '  ') do
    SearchText := System.StrUtils.ReplaceText(SearchText, '  ', ' ');
  Result.Text := System.StrUtils.ReplaceText(SearchText, ' ', #13#10);
end;

function TformMain.GetDelphiVersionStr(const aVersionStr: string): string;

begin
  Result := 'Unknown';
  if aVersionStr = '19.3' then
    Result := aVersionStr + ' (Delphi 11.0 Alexandria)'
  else if aVersionStr = '19.2' then
    Result := aVersionStr + ' (Delphi 10.4 Sydney Update 2)'
  else if aVersionStr = '19.1' then
    Result := aVersionStr + ' (Delphi 10.4 Sydney Update 1)'
  else if aVersionStr = '19.0' then
    Result := aVersionStr + ' (Delphi 10.4 Sydney)'
  else if aVersionStr = '18.8' then
    Result := aVersionStr + ' (Delphi 10.3 Rio Update 3)'
  else if aVersionStr = '18.7' then
    Result := aVersionStr + ' (Delphi 10.3 Rio Update 2)'
  else if aVersionStr = '18.6' then
    Result := aVersionStr + ' (Delphi 10.3 Rio Update 1)'
  else if aVersionStr = '18.5' then
    Result := aVersionStr + ' (Delphi 10.3 Rio)'
  else if aVersionStr = '18.4' then
    Result := aVersionStr + ' (Delphi 10.2 Tokyo Update 3)'
  else if aVersionStr = '18.3' then
    Result := aVersionStr + ' (Delphi 10.2 Tokyo Update 2)'
  else if aVersionStr = '18.2' then
    Result := aVersionStr + ' (Delphi 10.2 Tokyo or Delphi 10.1 Berlin Update 1)'
  else if aVersionStr = '18.1' then
    Result := aVersionStr + ' (Delphi 10.1 Berlin or Delphi 10 Seattle Update 1)'
  else if aVersionStr = '18.0' then
    Result := aVersionStr + ' (Delphi 10 Seattle)'
  else if aVersionStr = '17.2' then
    Result := aVersionStr + ' (Delphi XE8)'
  else if aVersionStr = '17.1' then
    Result := aVersionStr + ' (Delphi XE8)'
  else if aVersionStr = '16.1' then
    Result := aVersionStr + ' (Delphi XE7 Update 1)'
  else if aVersionStr = '16.0' then
    Result := aVersionStr + ' (Delphi XE7)'
  else if aVersionStr = '15.4' then
    Result := aVersionStr + ' (Delphi XE6)'
  else if aVersionStr = '15.3' then
    Result := aVersionStr + ' (Delphi XE5)'
  else if aVersionStr = '15.1' then
    Result := aVersionStr + ' (Delphi XE5)'
  else if aVersionStr = '14.6' then
    Result := aVersionStr + ' (Delphi XE4 Update 1)'
  else if aVersionStr = '14.4' then
    Result := aVersionStr + ' (Delphi XE4 or Delphi XE3 Update 2)'
  else if aVersionStr = '14.3' then
    Result := aVersionStr + ' (Delphi XE3)'
  else if aVersionStr = '13.4' then
    Result := aVersionStr + ' (Delphi XE2)'
  else if aVersionStr = '12.3' then
    Result := aVersionStr + ' (Delphi XE Update 1)'
  else if aVersionStr = '12.2' then
    Result := aVersionStr + ' (Delphi XE)'
  else if aVersionStr = '12.0' then
    Result := aVersionStr + ' (Delphi 2009 and 2010)';
end;

procedure TformMain.ShowProjectDetails;
begin
  if lvMRUProjects.SelCount = 1 then
  begin
    RichEditClearAll;

    FThisProjectPath := IncludeTrailingPathDelimiter(ExtractFilePath(lvMRUProjects.Selected.Caption));
    var ThisNotesFile := FThisProjectPath + NOTESFILENAME;
    if FileExists(ThisNotesFile) then
    begin
      richeditNotesEditor.Lines.LoadFromFile(ThisNotesFile);
      FOldLoadedNotesFile := ThisNotesFile;
      richeditNotesEditor.Tag := 0;

      if btnFilterNotes.Down and (not SearchBoxIsEmpty) then
      begin
        var SearchWordList := GetListOfFilterSearchWords;
        try
          for var i := 0 to SearchWordList.Count - 1 do
            HighLightAllWordsInRichEdit(richeditNotesEditor, SearchWordList[i], FSearchFilterColor, []);
          richeditNotesEditor.Tag := FRTFHASCHANGED;
        finally
          SearchWordList.Free;
        end;
      end;

      ShowOrHideNotesIndicator(True);
    end
    else
      ShowOrHideNotesIndicator(False);

    btnSaveRTF.Enabled := False;

    if lvMRUProjects.Selected.SubItems[0] = UNKNOWNSTR then
    begin
      CardPanelProjectDetails.ActiveCard := cardNoProjectSelected;
      EXIT;
    end;

    var ThisProjectFile := lvMRUProjects.Selected.Caption;

    lblProjectName.Caption := System.IOUtils.TPath.GetFileNameWithoutExtension(ThisProjectFile);
    lblCreatedDate.Caption := 'Created: ' + GetCreatedDateStr(ThisProjectFile);
    lblLastAccessed.Caption := 'Last Accessed : ' + GetAccessedDateStr(ThisProjectFile);

    var ThisProjectText := GetFileText(ThisProjectFile);

    var ThisDelphiVersion := GetValueFromBetweenTags(ThisProjectText, '<ProjectVersion>', '</ProjectVersion>');
    lblDelphiVersion.Caption := 'Delphi Version: ' + GetDelphiVersionStr(ThisDelphiVersion);

    var ThisFrameworkType := GetValueFromBetweenTags(ThisProjectText, '<FrameworkType>', '</FrameworkType>');
    lblFrameworkType.Caption := 'Framework Type: ' + ThisFrameworkType;

    var ThisAppType := GetValueFromBetweenTags(ThisProjectText, '<AppType>', '</AppType>');
    lblAppType.Caption := 'App Type: ' + ThisAppType;

    if btnFilterSourceFiles.Down and (not SearchBoxIsEmpty) then
    begin
      var SearchWordList := GetListOfFilterSearchWords;
      try
        FillListBoxWithSourceFiles(ThisProjectText, SearchWordList);
      finally
        SearchWordList.Free;
      end;
    end
    else
      FillListBoxWithSourceFiles(ThisProjectText);

    var ThisExeOutputDir := GetValueFromBetweenTags(ThisProjectText, '<DCC_ExeOutput>', '</DCC_ExeOutput>');
    if ThisExeOutputDir = '' then
      ThisExeOutputDir := '.';
    var ThisExpandedDir := System.SysUtils.IncludeTrailingPathDelimiter(System.SysUtils.ExpandFileName(IncludeTrailingPathDelimiter(ExtractFilePath(ThisProjectFile)) + ThisExeOutputDir));

    var ExePaths := GetSortedNoDuplicatesStringList;
    try
      var ThisRootExeFilePath := System.SysUtils.ChangeFileExt(ThisProjectFile, '.exe');
      begin
        if FileExists(ThisRootExeFilePath) then
          ExePaths.Add(ThisRootExeFilePath);
      end;

      begin
        var ThisExeFileName := ExtractFileName(ThisRootExeFilePath);

        var ThisExpandedDirWin32 := System.StrUtils.ReplaceText(ThisExpandedDir, '$(Platform)', 'Win32');
        var ThisExpandedDirWin32Debug := System.StrUtils.ReplaceText(ThisExpandedDirWin32, '$(Config)', 'Debug');
        var ThisWin32DebugExe := ThisExpandedDirWin32Debug + ThisExeFileName;
        if FileExists(ThisWin32DebugExe) then
          ExePaths.Add(ThisWin32DebugExe);

        var ThisExpandedDirWin32Release := System.StrUtils.ReplaceText(ThisExpandedDirWin32, '$(Config)', 'Release');
        var ThisWin32ReleaseExe := ThisExpandedDirWin32Release + ThisExeFileName;
        if FileExists(ThisWin32ReleaseExe) then
          ExePaths.Add(ThisWin32ReleaseExe);

        var ThisExpandedDirWin64 := System.StrUtils.ReplaceText(ThisExpandedDir, '$(Platform)', 'Win64');
        var ThisExpandedDirWin64Debug := System.StrUtils.ReplaceText(ThisExpandedDirWin64, '$(Config)', 'Debug');
        var ThisWin64DebugExe := ThisExpandedDirWin64Debug + ThisExeFileName;
        if FileExists(ThisWin64DebugExe) then
          ExePaths.Add(ThisWin64DebugExe);

        var ThisExpandedDirWin64Release := System.StrUtils.ReplaceText(ThisExpandedDirWin64, '$(Config)', 'Release');
        var ThisWin64ReleaseExe := ThisExpandedDirWin64Release + ThisExeFileName;
        if FileExists(ThisWin64ReleaseExe) then
          ExePaths.Add(ThisWin64ReleaseExe);

        listboxExeFiles.Clear;
        FExePairList.Clear;
        for var i := 0 to ExePaths.Count - 1 do
        begin
          var ThisRelativePath := System.StrUtils.ReplaceText(MyAbsToRel(ExePaths[i], ExtractFilePath(ThisProjectFile)), '.\', '');
          FExePairList.AddPair(ExePaths[i], ThisRelativePath);
          listboxExeFiles.Items.Add(ThisRelativePath);
        end;

      end;
    finally
      ExePaths.Free;
    end;

    lblExeVersionInfo.Caption := '';

    CardPanelProjectDetails.ActiveCard := cardProjectDetails;
  end
  else if lvMRUProjects.SelCount = 0 then
  begin
    CardPanelProjectDetails.ActiveCard := cardNoProjectSelected;
  end;
end;

procedure TformMain.FillListBoxWithSourceFiles(const aProjectText: string; aSearchWordsList: TStringList = nil);
begin
  FListOfSourceFilesContainingSearchWords.Clear;
  listboxProjectFiles.Clear;
  var ThisMainSourceFile := GetValueFromBetweenTags(aProjectText, '<MainSource>', '</MainSource>');
  var ThisMainSourceFilePath := FThisProjectPath + ThisMainSourceFile;
  if FileExists(ThisMainSourceFilePath) then
  begin
    listboxProjectFiles.Items.Add(ThisMainSourceFile);

    var ThisMainSourceText := GetFileText(ThisMainSourceFilePath);

    if SourcetextContainsAllSearchWords(ThisMainSourceText, aSearchWordsList) then
      FListOfSourceFilesContainingSearchWords.Add(ThisMainSourceFile);

    var RegexObj := TRegEx.Create('(?<='').*(?='')', [roIgnoreCase]);
    var MatchResult := RegexObj.Match(ThisMainSourceText);
    var ThisDFMFile: string;
    while MatchResult.Success do begin
      if FileExists(FThisProjectPath + MatchResult.Value) then
      begin
        listboxProjectFiles.Items.Add(MatchResult.Value);

        TryAddThisSourceFileToSearchResults(MatchResult.Value, aSearchWordsList);

        ThisDFMFile := System.SysUtils.ChangeFileExt(MatchResult.Value, '.dfm');
        if FileExists(FThisProjectPath + ThisDFMFile) then
        begin
          listboxProjectFiles.Items.Add(ThisDFMFile);
          TryAddThisSourceFileToSearchResults(ThisDFMFile, aSearchWordsList);
        end;
      end;
      MatchResult := MatchResult.NextMatch;
    end;
  end;
end;

procedure TformMain.TryAddThisSourceFileToSearchResults(const aListItem: string; aSearchWordsList: TStringList);
begin
  var ThisSourceText := GetFileText(FThisProjectPath + aListItem);
  if SourcetextContainsAllSearchWords(ThisSourceText, aSearchWordsList) then
    FListOfSourceFilesContainingSearchWords.Add(aListItem);
end;

function TformMain.SourcetextContainsAllSearchWords(const aSourceText: string; aSearchWordsList: TStringList): Boolean;
begin
  Result := False;
  if aSearchWordsList = nil then EXIT;

  var WordsFound := 0;
  for var i := 0 to aSearchWordsList.Count - 1 do
  begin
    if ContainsText(aSourceText, aSearchWordsList[i]) then
      Inc(WordsFound);
  end;
  if WordsFound = aSearchWordsList.Count then
    Result := True;
end;

function TformMain.ProjectsStr: string;
begin
  Result := ' MRU Projects';
  if FProjectListGroupMode then
    Result := ' GROUP Projects';
  if menuitemMODE_COMBINED.Checked then
    Result := ' COMBINED Projects';
end;

procedure TformMain.ShowFilteredStatus(const VisibleCount: Integer);
begin
  ShowProjectListCountInHeader(IntToStr(VisibleCount) + '/' + IntToStr(lvMRUProjects.Items.Count) + ProjectsStr);
end;

procedure TformMain.ShowProjectListCountInHeader(const aString: string);
begin
  lblProjectListCount.Caption := aString;
end;

function TformMain.GetModifiedDateStr(const aFile: string): string;
begin
  Result := '';
  var fad: Winapi.Windows.TWin32FileAttributeData;
  if Winapi.Windows.GetFileAttributesEx(PChar(aFile), GetFileExInfoStandard, @fad) then
  begin
    var SystemTime, LocalTime: Winapi.Windows.TSystemTime;
    if Winapi.Windows.FileTimeToSystemTime(fad.ftLastWriteTime, SystemTime) then
    begin
      if Winapi.Windows.SystemTimeToTzSpecificLocalTime(nil, SystemTime, LocalTime) then
      begin
        Result := System.SysUtils.DateTimeToStr(SystemTimeToDateTime(LocalTime));
      end;
    end;
  end;
end;

function TformMain.GetCreatedDateStr(const aFile: string): string;
begin
  Result := '';
  var fad: Winapi.Windows.TWin32FileAttributeData;
  if Winapi.Windows.GetFileAttributesEx(PChar(aFile), GetFileExInfoStandard, @fad) then
  begin
    var SystemTime, LocalTime: Winapi.Windows.TSystemTime;
    if Winapi.Windows.FileTimeToSystemTime(fad.ftCreationTime, SystemTime) then
    begin
      if Winapi.Windows.SystemTimeToTzSpecificLocalTime(nil, SystemTime, LocalTime) then
      begin
        Result := System.SysUtils.DateTimeToStr(SystemTimeToDateTime(LocalTime));
      end;
    end;
  end;
end;

function TformMain.GetAccessedDateStr(const aFile: string): string;
begin
  Result := '';
  var fad: Winapi.Windows.TWin32FileAttributeData;
  if Winapi.Windows.GetFileAttributesEx(PChar(aFile), GetFileExInfoStandard, @fad) then
  begin
    var SystemTime, LocalTime: Winapi.Windows.TSystemTime;
    if Winapi.Windows.FileTimeToSystemTime(fad.ftLastAccessTime, SystemTime) then
    begin
      if Winapi.Windows.SystemTimeToTzSpecificLocalTime(nil, SystemTime, LocalTime) then
      begin
        Result := System.SysUtils.DateTimeToStr(SystemTimeToDateTime(LocalTime));
      end;
    end;
  end;
end;

procedure TformMain.imgHeaderDropdownClick(Sender: TObject);
begin
  ShowIDESelectionPopupMenu;
end;

procedure TformMain.imgHeaderDropdownMouseEnter(Sender: TObject);
begin
  SetHeaderCaptionHot;
end;

procedure TformMain.imgHeaderDropdownMouseLeave(Sender: TObject);
begin
  SetHeaderCaptionBackToNormal;
end;

procedure TformMain.imgHeaderDropdownWhiteMouseEnter(Sender: TObject);
begin
  SetHeaderCaptionHot;
end;

procedure TformMain.imgHeaderDropdownWhiteMouseLeave(Sender: TObject);
begin
  SetHeaderCaptionBackToNormal;
end;

procedure TformMain.lblheaderCaptionClick(Sender: TObject);
begin
  ShowIDESelectionPopupMenu;
end;

procedure TformMain.SetHeaderCaptionHot;
begin
  lblheaderCaption.Transparent := False;
  lblheaderCaption.Font.Color := clWhite;
  pnlHeaderDropdownArrow.Color := lblheaderCaption.Color;
  imgHeaderDropdownWhite.Visible := True;
  imgHeaderDropdown.Visible := False;
end;

procedure TformMain.lblheaderCaptionMouseEnter(Sender: TObject);
begin
  SetHeaderCaptionHot;
end;

procedure TformMain.lblheaderCaptionMouseLeave(Sender: TObject);
begin
  if not FIDESelectionMenuOpened then
    SetHeaderCaptionBackToNormal;
end;

procedure TformMain.lvMRUProjectsColumnClick(Sender: TObject; Column: TListColumn);
begin
  DoColumnSort(Sender, Column.Index);
end;

procedure TformMain.DoColumnSort(aSender: TObject; const aColumnIndex: Integer; Clicked: Boolean = True);
begin
  if FOldSortedColumn <> -1 then
    SetListHeaderSortArrow(FOldSortedColumn, False);

  FSortedColumn := aColumnIndex;

  if FSortedColumn <> FOldSortedColumn then
  begin
    case FSortedColumn of
      0: FColumnSortedUp[FSortedColumn] := True;
      1: FColumnSortedUp[FSortedColumn] := False;
    end;
  end
  else
  begin
    if Clicked then
      FColumnSortedUp[FSortedColumn] := not FColumnSortedUp[FSortedColumn];
  end;

  FOldSortedColumn := FSortedColumn;

  SetListHeaderSortArrow(FSortedColumn, True);

  (aSender as TCustomListView).AlphaSort;
end;

procedure CheckPaintstage(Stage: TCustomDrawStage; itemIndex: Integer; canvas: TCanvas);
begin
  if Stage in [cdPrePaint, cdPreErase] then
  begin
    if System.Odd(itemIndex) then
    begin
      Canvas.Brush.Color := formMain.FAlternatingRowColor;
    end;
  end;
end;

procedure TformMain.actSubscriptCmdExecute(Sender: TObject);
begin
  richeditNotesEditor.SelAttributes.Subscript := sstSubscript;
end;

procedure TformMain.actSubscriptCmdUpdate(Sender: TObject);
begin
  (Sender as TAction).Checked := richeditNotesEditor.SelAttributes.Subscript = sstSubscript;
end;

procedure TformMain.actSuperscriptCmdExecute(Sender: TObject);
begin
  richeditNotesEditor.SelAttributes.Subscript := sstSuperscript;
end;

procedure TformMain.actSuperscriptCmdUpdate(Sender: TObject);
begin
  (Sender as TAction).Checked := richeditNotesEditor.SelAttributes.Subscript = sstSuperscript;
end;

procedure TformMain.ButtonSetIdealSize(AButton: TButton);
begin
  var S: TSize;
  S.cx := AButton.Width;
  if Winapi.CommCtrl.Button_GetIdealSize(AButton.Handle, S) then
    AButton.Height := S.cy;
end;

procedure TformMain.btnIncreaseUIFontSizeClick(Sender: TObject);
begin
  Self.Font.Size := Self.Font.Size + 1;
  SetLabelUIFontSize;
  ButtonsSetIdealSize;
  SetSpecialControls;
end;

procedure TformMain.SetSpecialControls;
begin
  lblAboutHomepage.Font.Size := Self.Font.Size;
  lblAboutEmail.Font.Size := Self.Font.Size;
  chkCustomizeRowHeight.Width := Self.Canvas.TextWidth(chkCustomizeRowHeight.Caption) + 32;
  chkShowInfoTips.Width := Self.Canvas.TextWidth(chkShowInfoTips.Caption) + 32;
  chkShowHintsInStatusBar.Width := Self.Canvas.TextWidth(chkShowHintsInStatusBar.Caption) + 32;
  lblHintHidePause.Width := Self.Canvas.TextWidth(lblHintHidePause.Caption) + 16;
end;

procedure TformMain.btnDecreaseUIFontSizeClick(Sender: TObject);
begin
  Self.Font.Size := Self.Font.Size - 1;
  SetLabelUIFontSize;
  ButtonsSetIdealSize;
  SetSpecialControls;
end;

procedure TformMain.ButtonsSetIdealSize;
begin
  ButtonSetIdealSize(btnIncreaseUIFontSizeEx);
  ButtonSetIdealSize(btnDecreaseUIFontSizeEx);
  ButtonSetIdealSize(btnClosePreferences);
end;

procedure TformMain.InitializeProjectFilesList(Sender: TObject);
begin
  if FOldFilterButton <> TToolButton(Sender) then
  begin
    searchboxProjectsList.Text := '';
    btnEmptySearchBox.Enabled := False;

    FOldFilterButton := TToolButton(Sender);
  end;
end;

procedure TformMain.btnFilterNotesClick(Sender: TObject);
begin
  SetSearchBoxEmptyText(SEARCHBOXEMPTYTEXT_Notes);
  InitializeProjectFilesList(Sender);
  btnGroup.Enabled := False;
  btnGroup.DropdownMenu := nil;
  lvMRUProjects.GroupView := False;
  UncheckAllpmGroupMenuItems;
  CardPanelProjectDetails.ActiveCard := cardNoProjectSelected;
end;

procedure TformMain.btnFilterProjectFilePathClick(Sender: TObject);
begin
  SetSearchBoxEmptyText(SEARCHBOXEMPTYTEXT_FilePaths);
  InitializeProjectFilesList(Sender);
  lvMRUProjects.OwnerDraw := True;
  btnGroup.Enabled := True;
  btnGroup.DropdownMenu := pmGroup;
  lvMRUProjects.GroupView := False;
  UncheckAllpmGroupMenuItems;
  CardPanelProjectDetails.ActiveCard := cardNoProjectSelected;
end;

procedure TformMain.btnFilterSourceFilesClick(Sender: TObject);
begin
  SetSearchBoxEmptyText(SEARCHBOXEMPTYTEXT_Sources);
  InitializeProjectFilesList(Sender);
  btnGroup.Enabled := False;
  btnGroup.DropdownMenu := nil;
  lvMRUProjects.GroupView := False;
  UncheckAllpmGroupMenuItems;
  CardPanelProjectDetails.ActiveCard := cardNoProjectSelected;
end;

procedure TformMain.btnGroupClick(Sender: TObject);
var
  Pt: Winapi.Windows.TPoint;
begin
  if not btnFilterProjectFilePath.Down then EXIT;

  Pt.X := btnGroup.Left;
  Pt.Y := btnGroup.Top + btnGroup.Height;
  Pt := btnGroup.Parent.ClientToScreen(Pt);
  pmGroup.Popup(Pt.X, Pt.Y);
  pmGroup.Items[0].MenuIndex := 0;
end;

procedure TformMain.btnGroupMouseEnter(Sender: TObject);
begin
  if btnFilterProjectFilePath.Down then
    btnGroup.Down := True
  else
    btnGroup.Enabled := False;
end;

procedure TformMain.btnGroupMouseLeave(Sender: TObject);
begin
  if not FpmGroupPopupIsOpened then
    btnGroup.Down := False;
end;

procedure TformMain.btnLoadSelectedProjectInExternalEditorClick(Sender: TObject);
begin
  OpenSelectedProjectInExternalEditor;
end;

procedure TformMain.OpenSelectedProjectInExternalEditor;
begin
  var SelectedProjectFile := lvMRUProjects.Selected;
  if not Assigned(SelectedProjectFile) then EXIT;
  TryOpenCodeFileInExternalEditor(SelectedProjectFile.Caption);
end;

procedure TformMain.TryOpenCodeFileInExternalEditor(const aFile: string);
begin
  if FileExists(aFile) then
  begin
    if FileExists(FExternalEditorFilepath) then
      Winapi.ShellAPI.ShellExecute(0, 'Open', PChar(FExternalEditorFilepath), PChar('"' + aFile + '"'), nil, SW_SHOWNORMAL)
    else
      Winapi.Windows.MessageBoxW(Handle, 'The External Editor does not exist.', PWideChar(Self.Caption), MB_OK + MB_ICONWARNING + MB_TOPMOST);
  end
  else
    Winapi.Windows.MessageBoxW(Handle, PWideChar('This file does not exist:' + #13#10#13#10 + aFile), PWideChar(Self.Caption), MB_OK + MB_ICONWARNING + MB_TOPMOST);
end;

procedure TformMain.btnShowDetailsPaneClick(Sender: TObject);
begin
  PALockWinControl(cardMain, True);
  try
    CardPanelProjectDetails.Visible := btnShowDetailsPane.Down;
    splMain.Visible := btnShowDetailsPane.Down;
  finally
    PALockWinControl(cardMain, False);
  end;
end;

procedure TformMain.btnSaveRTFClick(Sender: TObject);
begin
  richeditNotesEditor.Lines.SaveToFile(FThisProjectPath + NOTESFILENAME);

  btnSaveRTF.Enabled := False;
  ShowOrHideNotesIndicator(True);
end;

procedure TformMain.lvMRUProjectsAdvancedCustomDrawItem(Sender: TCustomListView; Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage; var DefaultDraw: Boolean);
begin
  if chkShowAlternatingRowShadows.Checked then
  begin
    if not (cdsSelected in State) then
      CheckPaintstage(Stage, item.Index, sender.canvas)
    else
      Sender.Canvas.Brush.Color := clHighlight;
  end;
end;

procedure TformMain.lvMRUProjectsAdvancedCustomDrawSubItem(Sender: TCustomListView; Item: TListItem; SubItem: Integer; State: TCustomDrawState; Stage: TCustomDrawStage; var DefaultDraw: Boolean);
begin
  if chkShowAlternatingRowShadows.Checked then
  begin
    if not (cdsSelected in State) then
      CheckPaintstage(Stage, Item.Index, Sender.canvas)
    else
      Sender.Canvas.Brush.Color := clHighlight;
  end;
end;

procedure TformMain.lvMRUProjectsCompare(Sender: TObject; Item1, Item2: Vcl.ComCtrls.TListItem; Data: Integer; var Compare: Integer);
var
  ix: Integer;
begin
  if FSortedColumn = 0 then
  begin
    if FColumnSortedUp[FSortedColumn] then
      Compare := CompareText(Item1.Caption, Item2.Caption)
    else
      Compare := CompareText(Item2.Caption, Item1.Caption);
  end
  else
  begin
    ix := FSortedColumn - 1;
    if FColumnSortedUp[FSortedColumn] then
      Compare := CompareText(Item1.SubItems[ix], Item2.SubItems[ix])
    else
      Compare := CompareText(Item2.SubItems[ix], Item1.SubItems[ix])
  end;
end;

procedure TformMain.SetListHeaderSortArrow(const aColumnIndex: Integer; const aEnabled: Boolean);
var
  Header: HWND;
  Item: Winapi.CommCtrl.THDItem;
begin
  Header := Winapi.CommCtrl.ListView_GetHeader(lvMRUProjects.Handle);
  Winapi.Windows.ZeroMemory(@Item, SizeOf(Item));
  Item.Mask := Winapi.CommCtrl.HDI_FORMAT;
  Winapi.CommCtrl.Header_GetItem(Header, aColumnIndex, Item);
  Item.fmt := Item.fmt and not (HDF_SORTUP or HDF_SORTDOWN);

  if aEnabled then
  begin
    if FColumnSortedUp[aColumnIndex] then
      Item.fmt := Item.fmt or HDF_SORTUP
    else
      Item.fmt := Item.fmt or HDF_SORTDOWN;
  end;

  Header_SetItem(Header, aColumnIndex, Item);
end;

procedure TformMain.SetModifiedColumnToIdealWidth;
begin
  if lvMRUProjects.Width < lvMRUProjects.Constraints.MinWidth then
  begin
    lvMRUProjects.Width := lvMRUProjects.Constraints.MinWidth + 32;
    EXIT;
  end;

  var ThisOffset: Integer;
  if lvMRUProjects.ClientWidth = lvMRUProjects.Width then
    ThisOffset := 11
  else
    ThisOffset := 28;

  lvMRUProjects.Columns[1].Width := lvMRUProjects.Canvas.TextWidth('8888-88-88 88:88:88') + ThisOffset;
  lvMRUProjects.Columns[0].Width := lvMRUProjects.Width - lvMRUProjects.Columns[1].Width;

  lvMRUProjects.Invalidate;
end;

procedure TformMain.lvMRUProjectsResize(Sender: TObject);
begin
  if FSortedColumn <> -1 then
    SetListHeaderSortArrow(FSortedColumn, True);
  ShowScrollBar(lvMRUProjects.Handle, SB_HORZ, False);

  SetModifiedColumnToIdealWidth;
end;

procedure TformMain.lvMRUProjectsMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  FWinControlToDrag := TWinControl(Sender);
  if (lvMRUProjects.SelCount = 1) and (DragDetectPlus(TWinControl(Sender))) then
  begin
    DropFileSourceMain.Files.Clear;
    DropFileSourceMain.Files.Add(lvMRUProjects.Selected.Caption);
    DropFileSourceMain.Execute;
  end;
end;

procedure TformMain.menuitemByYearClick(Sender: TObject);
begin
  var ThisYearStr := IntToStr(System.SysUtils.CurrentYear);
  var LastYearStr := IntToStr(System.SysUtils.CurrentYear - 1);
  lvMRUProjects.Items.BeginUpdate;
  try
    lvMRUProjects.GroupView := False;
    begin
      lvMRUProjects.ItemIndex := -1;
      var ThisSearchSuccess: Boolean;
      var VisibleItems := 0;
      for var i := 0 to lvMRUProjects.Items.Count - 1 do
      begin
        ThisSearchSuccess := SearchSuccessForProject(lvMRUProjects.Items[i].Caption, lvMRUProjects.Items[i].SubItems[0]);

        lvMRUProjects.Items[i].GroupID := -1;
        if System.StrUtils.ContainsText(lvMRUProjects.Items[i].SubItems[0], ThisYearStr) and ThisSearchSuccess then
        begin
          lvMRUProjects.Items[i].GroupID := 1;
          Inc(VisibleItems);
        end
        else if System.StrUtils.ContainsText(lvMRUProjects.Items[i].SubItems[0], LastYearStr) and ThisSearchSuccess then
        begin
          lvMRUProjects.Items[i].GroupID := 2;
          Inc(VisibleItems);
        end
        else
        begin
          if ThisSearchSuccess then
          begin
            lvMRUProjects.Items[i].GroupID := 3;
            Inc(VisibleItems);
          end;
        end;
      end;
      btnEmptySearchBox.Enabled := searchboxProjectsList.Text <> '';
      if btnEmptySearchBox.Enabled then
        ShowFilteredStatus(VisibleItems);
    end;
    lvMRUProjects.GroupView := True;
  finally
    lvMRUProjects.Items.EndUpdate;
  end;

  UncheckAllpmGroupMenuItems;
  menuitemByYear.Checked := True;
  FClickedGroupMenuItem := menuitemByYear;
  SetBtnGroupIconGrouped;
end;

function TformMain.SearchSuccessForProject(const aProjectFile, aModifiedStr: string): Boolean;
begin
  Result := True;
  if SearchBoxIsEmpty then EXIT;

  var ListSearchWords := TStringList.Create;
  try
    var SearchText := Trim(searchboxProjectsList.Text);
    while System.StrUtils.ContainsText(SearchText, '  ') do
      SearchText := System.StrUtils.ReplaceText(SearchText, '  ', ' ');
    ListSearchWords.Text := System.StrUtils.ReplaceText(SearchText, ' ', #13#10);
    var SearchWordFoundCount := 0;

    for var j := 0 to ListSearchWords.Count - 1 do
    begin
      if System.StrUtils.ContainsText(aProjectFile, ListSearchWords[j]) or System.StrUtils.ContainsText(aModifiedStr, ListSearchWords[j]) then
        Inc(SearchWordFoundCount);
    end;
    if SearchWordFoundCount <> ListSearchWords.Count then
      Result := False;
  finally
    ListSearchWords.Free;
  end;
end;

procedure TformMain.UncheckAllpmGroupMenuItems;
begin
  for var i := 0 to pmGroup.Items.Count - 1 do
    pmGroup.Items[i].Checked := False;
end;

procedure TformMain.SetHeaderCaptionBackToNormal;
begin
  lblheaderCaption.Transparent := True;
  lblheaderCaption.Font.Color := clGrayText;
  pnlHeaderDropdownArrow.Color := pnlProjectListHeader.Color;
  imgHeaderDropdown.Visible := True;
  imgHeaderDropdownWhite.Visible := False;
end;

procedure TformMain.ShowIDESelectionPopupMenu;
var
  Pt: Winapi.Windows.TPoint;
begin
  Pt.X := pnlProjectListHeader.Left;
  Pt.Y := pnlProjectListHeader.Top + pnlProjectListHeader.Height;
  Pt := pnlProjectListHeader.Parent.ClientToScreen(Pt);
  pmIDESelection.Popup(Pt.X, Pt.Y);
end;

procedure TformMain.menuitemUngroupClick(Sender: TObject);
begin
  DoUngroup(Sender);
  FClickedGroupMenuItem := nil;
  btnGroup.ImageIndex := 6;
end;

procedure TformMain.DoUngroup(Sender: TObject);
begin
  lvMRUProjects.Items.BeginUpdate;
  try
    lvMRUProjects.GroupView := False;
    DoFilterSearch(False);
  finally
    lvMRUProjects.Items.EndUpdate;
  end;
  if Assigned(Sender) then
  begin
    if SearchBoxIsEmpty then
      ShowUnfilteredStatus;
    UncheckAllpmGroupMenuItems;
  end;
end;

procedure TformMain.pmGroupClose(Sender: TObject);
begin
  FpmGroupPopupIsOpened := False;
  btnGroup.Down := False;
end;

procedure TformMain.pmGroupPopup(Sender: TObject);
begin
  btnGroup.Down := True;
  FpmGroupPopupIsOpened := True;
  menuitemUngroup.Enabled := lvMRUProjects.GroupView and IsAnyGroupMenuItemChecked;
end;

function TformMain.IsAnyGroupMenuItemChecked: Boolean;
begin
  Result := False;
  for var i := 0 to pmGroup.Items.Count - 1 do
  begin
    if pmGroup.Items[i].Checked then
    begin
      Result := True;
      BREAK;
    end;
  end;
end;

procedure TformMain.pmIDESelectionClose(Sender: TObject);
begin
  SetHeaderCaptionBackToNormal;
  FIDESelectionMenuOpened := False;
end;

procedure TformMain.pmIDESelectionPopup(Sender: TObject);
begin
  SetHeaderCaptionHot;
  FIDESelectionMenuOpened := True;
end;

procedure TformMain.searchboxProjectsListChange(Sender: TObject);
begin
  if SearchBoxIsEmpty then
    searchboxProjectsList.Color := clWindow
  else
  begin
    searchboxProjectsList.Color := FSearchFilterColor;
    FFirstSearchBoxWord := GetFirstSearchboxWord;
  end;

  DoFilterSearch;
end;

function TformMain.SearchBoxIsEmpty: Boolean;
begin
  Result := searchboxProjectsList.Text = '';
end;

procedure TformMain.TryDoCheckedGrouping;
begin
  if Assigned(FClickedGroupMenuItem) then
    TmenuItem(FClickedGroupMenuItem).Click;
end;

function RtfToText(const RTF_FilePath: string; ReplaceLineFeedWithSpace: Boolean): string;
var
  RTFConverter: TRichEdit;
  MyStringStream: TStringStream;
begin
  RTFConverter := TRichEdit.CreateParented(HWND_MESSAGE);
  try
    MyStringStream := TStringStream.Create(nil);
    try
      MyStringStream.LoadFromFile(RTF_FilePath);
      RTFConverter.Lines.LoadFromStream(MyStringStream);
      RTFConverter.PlainText := True;
      RTFConverter.Lines.StrictDelimiter := True;
      if ReplaceLineFeedWithSpace then
        RTFConverter.Lines.Delimiter := ' '
      else
        RTFConverter.Lines.Delimiter := #13;
      Result := RTFConverter.Lines.DelimitedText;
    finally
      MyStringStream.Free;
    end;
  finally
    RTFConverter.Free;
  end;
end;

function TformMain.GetListOfSourceFilesForProject(const aProject, aProjectPath: string): TStringList;
begin
  Result := TStringList.Create;
  var ThisProjectText := GetFileText(aProject);
  var ThisMainSourceFile := GetValueFromBetweenTags(ThisProjectText, '<MainSource>', '</MainSource>');
  var ThisMainSourceFilePath := aProjectPath + ThisMainSourceFile;
  if FileExists(ThisMainSourceFilePath) then
  begin
    Result.Add(ThisMainSourceFile);

    var ThisMainSourceText := GetFileText(ThisMainSourceFilePath);
    var RegexObj := TRegEx.Create('(?<='').*(?='')', [roIgnoreCase]);
    var MatchResult := RegexObj.Match(ThisMainSourceText);
    var ThisDFMFile: string;
    while MatchResult.Success do begin
      if FileExists(aProjectPath + MatchResult.Value) then
      begin
        Result.Add(MatchResult.Value);
        ThisDFMFile := System.SysUtils.ChangeFileExt(MatchResult.Value, '.dfm');
        if FileExists(aProjectPath + ThisDFMFile) then
          Result.Add(ThisDFMFile);
      end;
      MatchResult := MatchResult.NextMatch;
    end;
  end;
end;

procedure TformMain.DoFilterSearch(aFlag: Boolean = True);
begin
  var VisibleItems := 0;
  var IsGrouped: Boolean;
  var SearchCriteriaMet: Boolean;
  IsGrouped := IsAnyGroupMenuItemChecked and aFlag;

  lvMRUProjects.Items.BeginUpdate;
  try
    if SearchBoxIsEmpty then
    begin
      if not IsGrouped then
      begin
        lvMRUProjects.GroupView := False;
      end
      else
        TryDoCheckedGrouping;
      ShowUnfilteredStatus;
      btnEmptySearchBox.Enabled := False;
      EXIT;
    end
    else
    begin
      if not IsGrouped then
      begin
        btnEmptySearchBox.Enabled := True;
        lvMRUProjects.ItemIndex := -1;
        var SearchText := Trim(searchboxProjectsList.Text);
        while System.StrUtils.ContainsText(SearchText, '  ') do
          SearchText := System.StrUtils.ReplaceText(SearchText, '  ', ' ');

        var ListSearchWords := TStringList.Create;
        try
          ListSearchWords.Text := System.StrUtils.ReplaceText(SearchText, ' ', #13#10);
          var SearchWordFoundCount: Integer;
          var ThisNotesText: string;

          if btnFilterSourceFiles.Down then
          begin
            pbProjects.Max := lvMRUProjects.Items.Count;
            pbProjects.Position := 0;
            pbProjects.Enabled := True;
          end;

          for var i := 0 to lvMRUProjects.Items.Count - 1 do
          begin
            SearchCriteriaMet := False;
            if btnFilterNotes.Down then
            begin
              var ThisNotesFile := GetNotesFilePath(lvMRUProjects.Items[i].Caption);
              if FileExists(ThisNotesFile) then
                ThisNotesText := RtfToText(ThisNotesFile, False)
              else
                ThisNotesText := '';
            end
            else if btnFilterSourceFiles.Down then
            begin
              pbProjects.StepIt;
              var ThisProjectPath := IncludeTrailingPathDelimiter(ExtractFilePath(lvMRUProjects.Items[i].Caption));
              var ThisSourceFilesList := GetListOfSourceFilesForProject(lvMRUProjects.Items[i].Caption, ThisProjectPath);
              var ThisSourceFileText: string;
              var SearchWordsFound: Integer;
              try
                var ThisSearchWordsList := GetListOfFilterSearchWords;
                try
                  for var sourcefile := 0 to ThisSourceFilesList.Count - 1 do
                  begin
                    ThisSourceFileText := GetFileText(ThisProjectPath + ThisSourceFilesList[sourcefile]);
                    SearchWordsFound := 0;
                    for var searchword := 0 to ThisSearchWordsList.Count - 1 do
                    begin
                      if System.StrUtils.ContainsText(ThisSourceFileText, ThisSearchWordsList[searchword]) then
                      begin
                        Inc(SearchWordsFound);
                      end;
                    end;
                    if SearchWordsFound = ThisSearchWordsList.Count then
                    begin
                      SearchCriteriaMet := True;
                      BREAK;
                    end;
                  end;
                finally
                  ThisSearchWordsList.Free;
                end;
              finally
                ThisSourceFilesList.Free;
              end;
            end;

            SearchWordFoundCount := 0;
            for var j := 0 to ListSearchWords.Count - 1 do
            begin
              if btnFilterProjectFilePath.Down then
              begin
                SearchCriteriaMet := System.StrUtils.ContainsText(lvMRUProjects.Items[i].Caption, ListSearchWords[j]) or
                                     System.StrUtils.ContainsText(lvMRUProjects.Items[i].SubItems[0], ListSearchWords[j]);
              end
              else if btnFilterNotes.Down then
              begin
                SearchCriteriaMet := System.StrUtils.ContainsText(ThisNotesText, ListSearchWords[j]);
              end;

              if SearchCriteriaMet then
              begin
                if not IsGrouped then
                  lvMRUProjects.Items[i].GroupID := 0;
                Inc(SearchWordFoundCount);
              end;
            end;
            if (SearchWordFoundCount <> ListSearchWords.Count) then
              lvMRUProjects.Items[i].GroupID := -1
            else
            begin
              Inc(VisibleItems);
            end;
          end;
          pbProjects.Position := 0;
          pbProjects.Enabled := False;
        finally
          ListSearchWords.Free;
        end;
        ShowFilteredStatus(VisibleItems);
      end
      else
      begin
        if btnFilterProjectFilePath.Down then
          TryDoCheckedGrouping;
      end;
    end;
    lvMRUProjects.GroupView := True;
  finally
    lvMRUProjects.Items.EndUpdate;
  end;
end;

procedure TformMain.listboxExeFilesDblClick(Sender: TObject);
begin
  if listboxExeFiles.ItemIndex = -1 then EXIT;
  var ThisExeFullPath := FExePairList.Names[listboxExeFiles.ItemIndex];
  if FileExists(ThisExeFullPath) then
    Winapi.ShellAPI.ShellExecute(0, 'Open', PChar(ThisExeFullPath), nil, nil, SW_SHOWNORMAL);
end;

function TformMain.CurrText: TTextAttributes;
begin
  if richeditNotesEditor.SelLength > 0 then
    Result := richeditNotesEditor.SelAttributes
  else
    Result := richeditNotesEditor.DefAttributes;
end;

procedure TformMain.menuitemColorBackgroundClick(Sender: TObject);
begin
  dlgColor.Color := (richeditNotesEditor.SelAttributes.BackColor);
  if dlgColor.Execute then
  begin
    CurrText.BackColor := dlgColor.Color;
    richeditNotesEditor.SetFocus;
  end;
end;

procedure TformMain.menuitemColorForegroundClick(Sender: TObject);
begin
  dlgColor.Color := (richeditNotesEditor.SelAttributes.Color);
  if dlgColor.Execute then
  begin
    CurrText.Color := dlgColor.Color;
    richeditNotesEditor.SetFocus;
  end;
end;

procedure TformMain.menuitemDecreaseFontSizeClick(Sender: TObject);
begin
  var ThisCurrentText := CurrText;
  ThisCurrentText.Size := ThisCurrentText.Size - 1;
end;

procedure TformMain.menuitemFontClick(Sender: TObject);
begin
  FontDialog.Font.Assign(richeditNotesEditor.SelAttributes);
  if FontDialog.Execute then
  begin
    CurrText.Assign(FontDialog.Font);
    richeditNotesEditor.SetFocus;
  end;
end;

function TformMain.GetGroupID(const aGroupHeader: string): Integer;
begin
  Result := -1;
  for var i := lvMRUProjects.Groups.Count - 1 downto 0 do
  begin
    if lvMRUProjects.Groups[i].Header = aGroupHeader then
    begin
      Result := lvMRUProjects.Groups[i].GroupID;
      BREAK;
    end;
  end;
end;

procedure TformMain.menuitemGroupByAppTypeClick(Sender: TObject);
begin
  DoGroupByTagValues('<AppType>', '</AppType>');
  UncheckAllpmGroupMenuItems;
  menuitemGroupByAppType.Checked := True;
  FClickedGroupMenuItem := menuitemGroupByAppType;
  SetBtnGroupIconGrouped;
end;

procedure TformMain.menuitemGroupByFrameworkTypeClick(Sender: TObject);
begin
  DoGroupByTagValues('<FrameworkType>', '</FrameworkType>');
  UncheckAllpmGroupMenuItems;
  menuitemGroupByFrameworkType.Checked := True;
  FClickedGroupMenuItem := menuitemGroupByFrameworkType;
  SetBtnGroupIconGrouped;
end;

procedure TformMain.menuitemGroupByDelphiVersionClick(Sender: TObject);
begin
  UncheckAllpmGroupMenuItems;
  menuitemGroupByDelphiVersion.Checked := True;
  DoGroupByTagValues('<ProjectVersion>', '</ProjectVersion>');
  FClickedGroupMenuItem := menuitemGroupByDelphiVersion;
  SetBtnGroupIconGrouped;
end;

procedure TformMain.DoGroupByTagValues(const aStartTag, aEndTag: string);
begin
  Screen.Cursor := crHourGlass;
  try
    lvMRUProjects.Items.BeginUpdate;
    try
      DoUngroup(nil);

      var ThisProjectText: string;
      var ThisTagValue: string;
      var EmptyTagValue: string;
      var SLAllTagValues := GetSortedNoDuplicatesStringList;
      var ThisSearchSuccess: Boolean;
      try
        for var i := 0 to lvMRUProjects.Items.Count - 1 do
        begin
          if not FileExists(lvMRUProjects.Items[i].Caption) then CONTINUE;

          ThisProjectText := GetFileText(lvMRUProjects.Items[i].Caption);

          ThisTagValue := GetValueFromBetweenTags(ThisProjectText, aStartTag, aEndTag);
          if menuitemGroupByDelphiVersion.Checked then
            ThisTagValue := GetDelphiVersionStr(ThisTagValue);

          if lvMRUProjects.Items[i].SubItems.Count = 1 then
            lvMRUProjects.Items[i].SubItems.Add('');
          lvMRUProjects.Items[i].SubItems[1] := ThisTagValue;

          if ThisTagValue = '' then
            EmptyTagValue := EMPTYSTR
          else
            SLAllTagValues.Add(ThisTagValue);
        end;

        if EmptyTagValue <> '' then
        begin
          SLAllTagValues.Sorted := False;
          SLAllTagValues.Add(EmptyTagValue);
        end;

        for var i := lvMRUProjects.Groups.Count - 1 downto 0 do
        begin
          if lvMRUProjects.Groups[i].GroupID >= GROUPBYTAGVALUEOFFSET then
            lvMRUProjects.Groups.Delete(i)
          else
            BREAK;
        end;

        var ThisListGroup: TListGroup;
        for var i := 0 to SLAllTagValues.Count - 1 do
        begin
          ThisListGroup := lvMRUProjects.Groups.Add;
          ThisListGroup.Header := SLAllTagValues[i];
          ThisListGroup.GroupID := GROUPBYTAGVALUEOFFSET + i;
        end;
      finally
        SLAllTagValues.Free;
      end;

      lvMRUProjects.GroupView := False;
      var ThisGroupID: Integer;
      var VisibleItems: Integer;
      VisibleItems := 0;
      for var i := 0 to lvMRUProjects.Items.Count - 1 do
      begin
        lvMRUProjects.Items[i].GroupID := -1;
        if not FileExists(lvMRUProjects.Items[i].Caption) then CONTINUE;

        ThisTagValue := lvMRUProjects.Items[i].SubItems[1];
        if ThisTagValue = '' then
          ThisTagValue := EMPTYSTR;

        ThisGroupID := GetGroupID(ThisTagValue);
        ThisSearchSuccess := SearchSuccessForProject(lvMRUProjects.Items[i].Caption, lvMRUProjects.Items[i].SubItems[0]);
        if ThisGroupID > -1 then
        begin
          if ThisSearchSuccess then
          begin
            lvMRUProjects.Items[i].GroupID := ThisGroupID;
            Inc(VisibleItems);
          end;
        end;
      end;
      lvMRUProjects.GroupView := True;
      ShowFilteredStatus(VisibleItems);
    finally
      lvMRUProjects.Items.EndUpdate;
    end;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TformMain.edtExternalEditorChange(Sender: TObject);
begin
  SetExternalEditor;
end;

procedure TformMain.listboxProjectFilesDblClick(Sender: TObject);
begin
  if listboxProjectFiles.ItemIndex = -1 then EXIT;
  var ThisDoubleClickedFilePath := FThisProjectPath + listboxProjectFiles.Items[listboxProjectFiles.ItemIndex];
  TryOpenCodeFileInExternalEditor(ThisDoubleClickedFilePath);
end;

function TformMain.GetIconIdx(const aExtension: string): Integer;
begin
  Result := -1;

  if SameText(aExtension, '.DPR') then
    Result := FIconIdx_DPR
  else if SameText(aExtension, '.PAS') then
    Result := FIconIdx_PAS
  else if SameText(aExtension, '.DFM') then
    Result := FIconIdx_DFM
  else if SameText(aExtension, '.TXT') then
    Result := FIconIdx_TXT
  else if SameText(aExtension, '.DPK') then
    Result := FIconIdx_DPK
  else if SameText(aExtension, '.DCR') then
    Result := FIconIdx_DCR
  else if SameText(aExtension, '.EXE') then
    Result := FIconIdx_EXE;
end;

procedure TformMain.listboxExeFilesDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  CenterText: integer;
  FileInfo: SHFILEINFO;
  NewIcon: TIcon;
begin
  listboxExeFiles.Canvas.FillRect(Rect);
  NewIcon := TIcon.Create;
  try
    var ThisExeFilePath := FThisProjectPath + listboxExeFiles.Items.Strings[Index];
    SHGetFileInfo(PChar(ThisExeFilePath), 0, FileInfo, SizeOf(FileInfo), SHGFI_ICON or SHGFI_SMALLICON);
    NewIcon.Handle := FileInfo.hIcon;
    ilDummy.Clear;
    ilDummy.AddIcon(NewIcon);
    ilDummy.Draw(listboxExeFiles.Canvas, Rect.Left + 4, Rect.Top + 4, 0);
    CenterText := (Rect.Bottom - Rect.Top - listboxExeFiles.Canvas.TextHeight(text)) div 2 + 0;
    listboxExeFiles.Canvas.TextOut(Rect.left + ilDummy.Width + 8, Rect.Top + CenterText, listboxExeFiles.Items.Strings[Index]);
    DestroyIcon(FileInfo.hIcon);
  finally
    NewIcon.Free;
  end;
end;

procedure TformMain.listboxExeFilesMeasureItem(Control: TWinControl; Index: Integer; var Height: Integer);
begin
  Height := 20;
end;

procedure TformMain.listboxProjectFilesDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  CenterText: integer;
begin
  listboxProjectFiles.Canvas.FillRect(Rect);
  if Index = 0 then
    listboxProjectFiles.Canvas.Font.Style := [fsBold]
  else
    listboxProjectFiles.Canvas.Font.Style := [];

  if btnFilterSourceFiles.Down and (not SearchBoxIsEmpty) then
  begin
    if FListOfSourceFilesContainingSearchWords.IndexOf(listboxProjectFiles.Items[Index]) > -1 then
    begin
      if odSelected in State then
      begin
        listboxProjectFiles.Canvas.Brush.Color := clHighLight;
        listboxProjectFiles.Canvas.Font.Color := FSearchFilterColor;
      end
      else
      begin
        listboxProjectFiles.Canvas.Brush.Color := FSearchFilterColor;
        listboxProjectFiles.Canvas.Font.Color := clWindowText;
      end;
    end
    else
    begin
      if odSelected in State then
      begin
        listboxProjectFiles.Canvas.Brush.Color := clHighLight;
        listboxProjectFiles.Canvas.Font.Color := clHighlightText;
      end
      else
      begin
        listboxProjectFiles.Canvas.Brush.Color := listboxProjectFiles.Color;
        listboxProjectFiles.Canvas.Font.Color := clWindowText;
      end;
    end;
  end;

  ilShellIcons.Draw(listboxProjectFiles.Canvas, Rect.Left + 4, Rect.Top + 4, GetIconIdx(ExtractFileExt(listboxProjectFiles.Items.Strings[Index])));
  CenterText := (Rect.Bottom - Rect.Top - listboxProjectFiles.Canvas.TextHeight(text)) div 2 + 0;
  listboxProjectFiles.Canvas.TextOut(Rect.left + ilShellIcons.Width + 8, Rect.Top + CenterText, listboxProjectFiles.Items.Strings[Index]);
end;

procedure TformMain.listboxProjectFilesMeasureItem(Control: TWinControl; Index: Integer; var Height: Integer);
begin
  Height := 20;
end;

function TformMain.GetProjectPath(const aProject: string): string;
begin
  Result := IncludeTrailingPathDelimiter(ExtractFilePath(aProject));
end;

function TformMain.GetNotesFilePath(const aProject: string): string;
begin
  Result := GetProjectPath(aProject) + NOTESFILENAME;
end;

procedure TformMain.menuitemGroupByNotesClick(Sender: TObject);
begin
  var ThisNotesFile: string;
  lvMRUProjects.Items.BeginUpdate;
  try
    lvMRUProjects.ItemIndex := -1;
    lvMRUProjects.GroupView := False;
    var ThisSearchSuccess: Boolean;
    var VisibleItems := 0;
    for var i := 0 to lvMRUProjects.Items.Count - 1 do
    begin
      ThisSearchSuccess := SearchSuccessForProject(lvMRUProjects.Items[i].Caption, lvMRUProjects.Items[i].SubItems[0]);

      lvMRUProjects.Items[i].GroupID := -1;
      ThisNotesFile := GetNotesFilePath(lvMRUProjects.Items[i].Caption);
      if FileExists(ThisNotesFile) then
      begin
        if ThisSearchSuccess then
        begin
          lvMRUProjects.Items[i].GroupID := 4;
          Inc(VisibleItems);
        end;
      end
      else
      begin
        if ThisSearchSuccess then
        begin
          lvMRUProjects.Items[i].GroupID := 5;
          Inc(VisibleItems);
        end;
      end;
    end;
    lvMRUProjects.GroupView := True;
    btnEmptySearchBox.Enabled := searchboxProjectsList.Text <> '';
    if btnEmptySearchBox.Enabled then
      ShowFilteredStatus(VisibleItems);
  finally
    lvMRUProjects.Items.EndUpdate;
  end;

  UncheckAllpmGroupMenuItems;
  menuitemGroupByNotes.Checked := True;
  FClickedGroupMenuItem := menuitemGroupByNotes;
  SetBtnGroupIconGrouped;
end;

procedure TformMain.SetBtnGroupIconGrouped;
begin
  btnGroup.ImageIndex := 25;
end;

procedure TformMain.menuitemIncreaseFontSizeClick(Sender: TObject);
begin
  var ThisCurrentText := CurrText;
  ThisCurrentText.Size := ThisCurrentText.Size + 1;
end;

procedure TformMain.menuitemIndentDecreaseClick(Sender: TObject);
begin
  richeditNotesEditor.Paragraph.FirstIndent := richeditNotesEditor.Paragraph.FirstIndent - 10;
  menuitemIndentDecrease.Enabled := richeditNotesEditor.Paragraph.FirstIndent > 9;
end;

procedure TformMain.menuitemIncreaseTheWidthOfTheSearchBoxClick(Sender: TObject);
begin
  DoIncreaseSearchBoxWidth;
end;

procedure TformMain.DoIncreaseSearchBoxWidth;
begin
  searchboxProjectsList.Width := searchboxProjectsList.Width + 10;
end;

procedure TformMain.menuitemDecreaseTheWidthOfTheSearchBoxClick(Sender: TObject);
begin
  DoDecreaseSearchBoxWidth;
end;

procedure TformMain.DoDecreaseSearchBoxWidth;
begin
  searchboxProjectsList.Width := searchboxProjectsList.Width - 10;
end;

procedure TformMain.listboxExeFilesMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (listboxExeFiles.ItemIndex <> -1) then
  begin
    FWinControlToDrag := TWinControl(Sender);
    if DragDetectPlus(TWinControl(Sender)) then
    begin
      DropFileSourceMain.Files.Clear;
      DropFileSourceMain.Files.Add(FThisProjectPath + listboxExeFiles.Items[listboxExeFiles.ItemIndex]);
      DropFileSourceMain.Execute;
    end
    else if Button = mbLeft then
    begin
      var ThisExeFullPath := FExePairList.Names[listboxExeFiles.ItemIndex];
      if FileExists(ThisExeFullPath) then
      begin
        RzVersionInfoMain.FilePath := ThisExeFullPath;
        if RzVersionInfoMain.VersionInfoAvailable then
        begin
          lblExeVersionInfo.Caption :=
            'Product Version: '  + RzVersionInfoMain.ProductVersion  + #13#10 +
            'File Version: '     + RzVersionInfoMain.FileVersion     + #13#10 +
            'Product Name: '     + RzVersionInfoMain.ProductName     + #13#10 +
            'File Description: ' + RzVersionInfoMain.FileDescription + #13#10 +
            'Comments: '         + RzVersionInfoMain.Comments        + #13#10 +
            'Date: '             + FormatDateTime('YYYY-mm-dd', RzVersionInfoMain.FileDateTime);
        end
        else
          lblExeVersionInfo.Caption := 'Version Information not available.';
      end;
      lblExeInfo.Top := lblExeVersionInfo.Top + lblExeVersionInfo.Height + 1;
    end;
  end;
end;

procedure TformMain.listboxProjectFilesMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  FWinControlToDrag := TWinControl(Sender);
  if (listboxProjectFiles.ItemIndex <> -1) and (DragDetectPlus(TWinControl(Sender))) then
  begin
    DropFileSourceMain.Files.Clear;
    DropFileSourceMain.Files.Add(FThisProjectPath + listboxProjectFiles.Items[listboxProjectFiles.ItemIndex]);
    DropFileSourceMain.Execute;
  end;
end;

type
  TSubstringMatch = record
    Start, Length: Integer;
  end;

function SubstringMatch(AStart, ALength: Integer): TSubstringMatch;
begin
  Result.Start := AStart;
  Result.Length := ALength;
end;

function SubstringSearch(const AText, ASubstring: string): TArray<TSubstringMatch>;
begin
  var List := System.Generics.Collections.TList<TSubstringMatch>.Create;
  try
    var p := 1;
    repeat
      p := System.StrUtils.PosEx(Uppercase(ASubstring), Uppercase(AText), p);
      if p <> 0 then
      begin
        List.Add(SubstringMatch(p, ASubstring.Length));
        Inc(p, ASubstring.Length);
      end;
    until p = 0;
    Result := List.ToArray;
  finally
    List.Free;
  end;
end;

procedure TformMain.lvMRUProjectsDrawItem(Sender: TCustomListView; Item: TListItem; Rect: TRect; State: TOwnerDrawState);
const
  Alignments: array[TAlignment] of TTextFormats = (tfLeft, tfRight, tfCenter);

  procedure SetCanvasColors(const aBrushColor, aFontColor: TColor; const aFontStyles: TFontStyles = []);
  begin
    (Sender as TListView).Canvas.Brush.Color := aBrushColor;
    (Sender as TListView).Canvas.Font.Color := aFontColor;
    (Sender as TListView).Canvas.Font.Style := aFontStyles;
  end;
begin
  if not Assigned(Item) then EXIT;
  var SelectionColor := clHighlight;
  var LV := Sender as TListView;

  if (searchboxProjectsList.Text = '') or btnFilterNotes.Down or btnFilterSourceFiles.Down then
  begin

    if odSelected in State then
    begin
      LV.Canvas.Brush.Color := SelectionColor;
      LV.Canvas.Font.Color := clHighlightText;
    end
    else
    begin
      if chkShowAlternatingRowShadows.Checked then
      begin
        if Item.Index mod 2 = 0 then
          LV.Canvas.Brush.Color := FAlternatingRowColor
        else
          LV.Canvas.Brush.Color := clWindow;
      end
      else
        LV.Canvas.Brush.Color := clWindow;

      LV.Canvas.Font.Color := clWindowtext;
    end;
    LV.Canvas.Brush.Style := bsSolid;
    LV.Canvas.FillRect(Rect);

    var x1 := 0;
    var x2 := 0;
    var RR := Rect;
    var SS: string;
    LV.Canvas.Brush.Style := bsClear;

    for var i := 0 to 1 do
    begin
      Inc(x2, LV.Columns[i].Width);
      RR.Left := x1;
      RR.Right := x2;
      if i = 0 then
        SS := Item.Caption
      else
      begin
        SS := Item.SubItems[i - 1];
      end;
      SS := #32 + SS;

      if i = 0 then
      begin
        var h := RR.Bottom - RR.Top;
        ilIDEs.Draw(LV.Canvas, RR.Left + 4, RR.Top + (h - 14) div 2, Item.ImageIndex);
        RR.Left := RR.Left + 20;
      end;

      LV.Canvas.TextRect(RR, SS, [tfSingleLine, Alignments[LV.Columns[i].Alignment], tfVerticalCenter]);

      x1 := x2;
    end;
  end
  else
  begin

    if odSelected in State then
    begin
      LV.Canvas.Brush.Color := SelectionColor;
      LV.Canvas.Font.Color := clHighlightText;
    end
    else
    begin
      if chkShowAlternatingRowShadows.Checked then
      begin
        if Item.Index mod 2 = 0 then
          LV.Canvas.Brush.Color := FAlternatingRowColor
        else
          LV.Canvas.Brush.Color := clWindow;
      end
      else
        LV.Canvas.Brush.Color := clWindow;

      LV.Canvas.Font.Color := clWindowtext;
    end;
    LV.Canvas.Brush.Style := bsSolid;
    LV.Canvas.FillRect(Rect);

    var x1 := 0;
    var x2 := 0;
    var RR := Rect;
    var SS: string;
    LV.Canvas.Brush.Style := bsClear;

    var CaptionMatch:  Boolean;
    var ModifiedMatch: Boolean;

    for var i := 0 to 1 do
    begin
      Inc(x2, LV.Columns[i].Width);
      RR.Left := x1;
      RR.Right := x2;
      if i = 0 then
        SS := Item.Caption
      else
      begin
        SS := Item.SubItems[i - 1];
      end;
      SS := #32 + SS;

      var LMatches := SubstringSearch(SS, FFirstSearchBoxWord);
      var LItemText := SS;
      var R := RR;
      var C := Sender.Canvas;

      if i = 1 then
      begin
        if CaptionMatch then
        begin
          C.TextRect(RR, SS, [tfSingleLine, tfVerticalCenter, tfLeft]);
          CONTINUE;
        end;
      end;

      var p := 1;
      for var Match in LMatches do
      begin
        if (i = 0) and (p = 1) then
        begin
          var h := R.Bottom - R.Top;
          ilIDEs.Draw(LV.Canvas, R.Left + 4, R.Top + (h - 14) div 2, Item.ImageIndex);
          R.Left := R.Left + 20;
        end;

        var S := Copy(LItemText, p, Match.Start - p);

        if ([odSelected, odHotLight] * State <> []) then
        begin
          SetCanvasColors(SelectionColor, clHighlightText);
        end
        else
          SetCanvasColors(clWindow, clWindowText);

        C.TextRect(R, S, [tfSingleLine, tfVerticalCenter, tfLeft]);
        Inc(R.Left, C.TextWidth(S));

        S := Copy(LItemText, Match.Start, Match.Length);

        if ([odSelected, odHotLight] * State <> []) then
        begin
          SetCanvasColors(SelectionColor, FSearchFilterColor, [fsBold]);
        end
        else
          SetCanvasColors(FSearchFilterColor, clWindowText);

        C.TextRect(R, S, [tfSingleLine, tfVerticalCenter, tfLeft]);
        Inc(R.Left, C.TextWidth(S));

        p := Match.Start + Match.Length;

        S := Copy(LItemText, p);

        if ([odSelected, odHotLight] * State <> []) then
          SetCanvasColors(SelectionColor, clHighlightText)
        else
          SetCanvasColors(clWindow, clWindowText);

        C.TextRect(R, S, [tfSingleLine, tfVerticalCenter, tfLeft]);
      end;

      CaptionMatch := (i = 0) and (Length(LMatches) > 0);
      ModifiedMatch := (i = 1) and (Length(LMatches) > 0);

      if ModifiedMatch then
      begin
        RR.Left := 0;
        RR.Right := LV.Columns[0].Width;
        SS := #32 + Item.Caption;

        if ([odSelected, odHotLight] * State <> []) then
          SetCanvasColors(SelectionColor, clHighlightText)
        else
          SetCanvasColors(clWindow, clWindowText);

        var h := RR.Bottom - RR.Top;
        ilIDEs.Draw(LV.Canvas, RR.Left + 4, RR.Top + (h - 14) div 2, Item.ImageIndex);
        RR.Left := RR.Left + 20;

        C.TextRect(RR, SS, [tfSingleLine, tfVerticalCenter, tfLeft]);
      end;

      x1 := x2;
    end;
  end;
end;

function TformMain.GetFirstSearchboxWord: string;
begin
  Result := Trim(searchboxProjectsList.Text);
  var FirstSpacePos := Pos(' ', Result);
  if FirstSpacePos <> 0 then
    Result := LeftStr(Result, FirstSpacePos - 1);
end;

procedure TformMain.menuitemResetTheDefaultWidthOfTheSearchBoxClick(Sender: TObject);
begin
  searchboxProjectsList.Width := FDefaultSearchBoxWidth;
end;

procedure TformMain.menuitemIndentIncreaseClick(Sender: TObject);
begin
  richeditNotesEditor.Paragraph.FirstIndent := richeditNotesEditor.Paragraph.FirstIndent + 10;
  menuitemIndentDecrease.Enabled := True;
end;

procedure TformMain.menuitemZoomDEFAULTClick(Sender: TObject);
begin
  richeditNotesEditor.Zoom := 100;
end;

procedure TformMain.menuitemZoomINClick(Sender: TObject);
begin
  richeditNotesEditor.Zoom := richeditNotesEditor.Zoom + 10;
end;

procedure TformMain.menuitemZoomOUTClick(Sender: TObject);
begin
  richeditNotesEditor.Zoom := richeditNotesEditor.Zoom - 10;
end;

procedure TformMain.pgcProjectDetailsChange(Sender: TObject);
begin
  case pgcProjectDetails.ActivePageIndex of
    0:
      begin
        tsNotes.ImageIndex := 10;
        tsgeneral.ImageIndex := 18;
        tsExe.ImageIndex := 20;
        tsFiles.ImageIndex := 21;
      end;
    1:
      begin
        tsNotes.ImageIndex := 19;
        tsgeneral.ImageIndex := 9;
        tsExe.ImageIndex := 20;
        tsFiles.ImageIndex := 21;
      end;
    2:
      begin
        tsNotes.ImageIndex := 19;
        tsgeneral.ImageIndex := 18;
        tsExe.ImageIndex := 11;
        tsFiles.ImageIndex := 21;
      end;
    3:
      begin
        tsNotes.ImageIndex := 19;
        tsgeneral.ImageIndex := 18;
        tsExe.ImageIndex := 20;
        tsFiles.ImageIndex := 16;
      end;
  end;
end;

procedure TformMain.pmNotesPopup(Sender: TObject);
begin
  var IsTextSelected := richeditNotesEditor.SelLength > 0;
  menuitemIncreaseFontSize.Enabled := IsTextSelected;
  menuitemDecreaseFontSize.Enabled := IsTextSelected;
  menuitemPastePlainText.Enabled := Vcl.Clipbrd.Clipboard.AsText <> '';
end;

procedure TformMain.richeditNotesEditorChange(Sender: TObject);
begin
  if richeditNotesEditor.Tag = FRTFHASCHANGED then
  begin
    DoReloadOriginalNotesFile;
    richeditNotesEditor.Tag := 0;
    EXIT;
  end;

  btnSaveRTF.Enabled := True;
end;

procedure TformMain.richeditNotesEditorClick(Sender: TObject);
begin
  menuitemIndentDecrease.Enabled := richeditNotesEditor.Paragraph.FirstIndent > 9;
end;

procedure TformMain.richeditNotesEditorLinkClick(Sender: TCustomRichEdit; const URL: string; Button: TMouseButton);
begin
  if (Button = mbLeft) and (MessageDlg(Format(OPENLINKSTR, [URL]), mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
    Winapi.ShellAPI.ShellExecute(Handle, 'open', PChar(URL), nil, nil, SW_SHOWNORMAL);
end;

procedure TformMain.menuitemReloadNotesFileClick(Sender: TObject);
begin
  DoReloadOriginalNotesFile;
end;

procedure TformMain.DoReloadOriginalNotesFile;
begin
  if FileExists(FOldLoadedNotesFile) then
    richeditNotesEditor.Lines.LoadFromFile(FOldLoadedNotesFile);
  btnSaveRTF.Enabled := False;
end;

procedure TformMain.lvMRUProjectsKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Shift = [ssCtrl] then
  begin
    case Key of
      VK_C_: TryCopySelectedProjectFilePath;
    end;
  end;
end;

function MyResolveLink(const aLinkPath: string): string;
var
  Link: Winapi.ShlObj.IShellLink;
  Storage: Winapi.ActiveX.IPersistFile;
  FileData: TWin32FindData;
  Buf: Array[0..MAX_PATH] of Char;
  WidePath: WideString;
begin
  Vcl.OleAuto.OleCheck(CoCreateInstance(CLSID_ShellLink, nil, CLSCTX_INPROC_SERVER, IShellLink, Link));
  Vcl.OleAuto.OleCheck(Link.QueryInterface(IPersistFile, Storage));
  WidePath := aLinkPath;
  Result := 'Unable to resolve link';
  If Succeeded( Storage.Load(@WidePath[1], STGM_READ)) then
  begin
    If Succeeded( Link.Resolve(GetActiveWindow, SLR_NOUPDATE)) then
    begin
      If Succeeded(Link.GetPath(Buf, sizeof(Buf), FileData, SLGP_UNCPRIORITY)) then
        Result := Buf;
    end;
  end;
  Storage := nil;
  Link:= nil;
end;

function CreateShellLink(const aTargetFile, aLinkFile, aDescription: string): Boolean;
var
  IObject: IUnknown;
  ISLink: IShellLink;
  IPFile: IPersistFile;
begin
  Result := False;

  IObject := System.Win.ComObj.CreateComObject(CLSID_ShellLink);
  ISLink := IObject as Winapi.ShlObj.IShellLink;
  IPFile := IObject as Winapi.ActiveX.IPersistFile;

  with ISLink do
  begin
    SetDescription(PChar(aDescription));
    SetPath(PChar(aTargetFile));
    SetWorkingDirectory(PChar(System.SysUtils.ExtractFilePath(aTargetFile)));
  end;

  if not FileExists(aLinkFile) then
  begin
    if IPFile.Save(PWideChar(aLinkFile), False) = S_OK then
      Result := True;
  end;
end;

function TformMain.GetTargetFileFromLinkFile(const aLinkFilePath: string): string;
var
  ThisLinkData: RzShellUtils.TLinkData;
begin
  Result := '';
  RzShellUtils.ResolveShortcut(aLinkFilePath, ThisLinkData, False);
  Result := ThisLinkData.pathName;
end;

procedure TformMain.AddProjectLinkToSelectedProjectGroupFolder(const aProjectFilePath: string);
begin
  var ThisExtension := System.SysUtils.ExtractFileExt(aProjectFilePath);
  if not System.SysUtils.SameText(ThisExtension, '.DPROJ') then EXIT;
  var ThisTargetPath := System.SysUtils.IncludeTrailingPathDelimiter((RzShellTreeGroups.GetDataFromNode(RzShellTreeGroups.Selected)).PathName);
  var TargetLinkFile := ThisTargetPath + System.SysUtils.ChangeFileExt(System.SysUtils.ExtractFileName(aProjectFilePath), '.lnk');
  if FileExists(TargetLinkFile) then
  begin
    var LList: System.Types.TStringDynArray;
    LList := TDirectory.GetFiles(ThisTargetPath, '*.LNK', TSearchOption.soTopDirectoryOnly);
    var LinkTargetFoundInGroupFolder: Boolean := False;
    for var i := 0 to Length(LList) - 1 do
    begin
      var TargetFileOfExistingLink := GetTargetFileFromLinkFile(LList[i]);
      if SameText(TargetFileOfExistingLink, aProjectFilePath) then
      begin
        LinkTargetFoundInGroupFolder := True;
        BREAK;
      end;
    end;
    if LinkTargetFoundInGroupFolder then
    begin
      MessageBoxW(Handle, 'This very Project already exists in this Project Group.', PWideChar(Application.Title), MB_OK + MB_ICONINFORMATION + MB_TOPMOST);
      EXIT;
    end
    else
    begin
      var RenamedTargetLinkFile := GetNewFilePathVersion(TargetLinkFile);
      if RenamedTargetLinkFile <> '' then
        DoCreateGroupLink(aProjectFilePath, RenamedTargetLinkFile)
      else
      begin
        MessageBoxW(Handle, 'Too many versions of the same Project in this Project-Group.', PWideChar(Application.Title), MB_OK + MB_ICONSTOP + MB_TOPMOST);
      end;
    end;
  end
  else
  begin
    DoCreateGroupLink(aProjectFilePath, TargetLinkFile);
  end;
end;

procedure TformMain.DoCreateGroupLink(const aProjectFilePath, aTargetLinkFile: string);
begin
  if CreateShellLink(aProjectFilePath, aTargetLinkFile, 'Shortcut Link created by Delphi MRU Project Manager') then
  begin
    DoAppendGroupNodesInformation;
  end
  else
    MessageBoxW(Handle, 'The operation did not succeed.', PWideChar(Application.Title), MB_OK + MB_ICONSTOP + MB_TOPMOST);
end;

function TformMain.GetNewFilePathVersion(const aFilePath: string): string;
var
  ThisFilePath, ThisFileNameNoExt, ThisExt: string;
  var ThisNumber: Integer;

  function IncrementedFileName(const aNumber: Integer): string;
  begin
    Result := ThisFilePath + ThisFileNameNoExt + '_' + IntToStr(aNumber) + ThisExt;
  end;
begin
  Result := '';

  ThisFilePath := IncludeTrailingPathDelimiter(ExtractFilePath(aFilePath));
  ThisFileNameNoExt := System.IOUtils.TPath.GetFileNameWithoutExtension(aFilePath);
  ThisExt := ExtractFileExt(aFilePath);
  ThisNumber := 0;
  repeat
    Inc(ThisNumber);
    Result := IncrementedFileName(ThisNumber);
  until (not FileExists(Result)) or (ThisNumber > 999);
  if FileExists(Result) then
    Result := '';
end;

procedure TformMain.DropFileTargetGroupsDragOver(Sender: TObject; ShiftState: TShiftState; APoint: Winapi.Windows.TPoint; var Effect: Integer);
begin
  var NodeDragOver := RzShellTreeGroups.GetNodeAt(APoint.X, APoint.Y);
  if Assigned(NodeDragOver) then
  begin
    if NodeDragOver.AbsoluteIndex > 0 then
    begin
      Self.ActiveControl := RzShellTreeGroups;
      NodeDragOver.Expanded := True;
      RzShellTreeGroups.Select(NodeDragOver);
      Effect := 1;
    end
    else
      Effect := 0;
  end
  else
    Effect := 0;
end;

procedure TformMain.DropFileTargetGroupsDrop(Sender: TObject; ShiftState: TShiftState; APoint: Winapi.Windows.TPoint; var Effect: Integer);
begin
  var NodeDroppedOn := RzShellTreeGroups.GetNodeAt(APoint.X, APoint.Y);
  var DroppedFiles := TStringList.Create;
  try
    DroppedFiles.Text := DropFileTargetGroups.Files.Text;
    Screen.Cursor := crHourGlass;
    try
      for var i := 0 to DroppedFiles.Count - 1 do
      begin
        AddProjectLinkToSelectedProjectGroupFolder(DroppedFiles[i]);
      end;
    finally
      Screen.Cursor := crDefault;
    end;
  finally
    DroppedFiles.Free;
  end;
end;

function TformMain.MyGetNodeFromNodeIndex(const aIdx: Integer): TTreeNode;
var
  Node: TTreeNode;
begin
  Result := nil;
  for Node in RzShellTreeGroups.Items do
  begin
    Result := nil;
    if Node.AbsoluteIndex = aIdx then
    begin
      Result := Node;
      EXIT;
    end;
  end;
end;

function TformMain.IsExistingProjectFilePathTextInClipboard: Boolean;
begin
  Result := False;
  var ProjectFilePathTextOnClipboard: Boolean := False;
  var ThisClipboardText := Vcl.Clipbrd.Clipboard.AsText;
  if SameText(ExtractFileExt(ThisClipboardText), '.DPROJ') then
  begin
    if FileExists(ThisClipboardText) then
      Result := True;
  end;
end;

procedure TformMain.menuitemPasteTheProjectFromTheClipboardClick(Sender: TObject);
begin
  if IsExistingProjectFilePathTextInClipboard then
  begin
    var ThisClipboardText := Vcl.Clipbrd.Clipboard.AsText;
    AddProjectLinkToSelectedProjectGroupFolder(ThisClipboardText);
  end
  else if IsExistingProjectFileInClipboard then
  begin
    var ThisClipboardFile := ClipboardGetAsFile;
    AddProjectLinkToSelectedProjectGroupFolder(ThisClipboardFile);
  end;
end;

procedure TformMain.pmProjectGroupsPopup(Sender: TObject);
begin
  menuitemPasteTheProjectFromTheClipboard.Enabled := (IsExistingProjectFilePathTextInClipboard or IsExistingProjectFileInClipboard) and (RzShellTreeGroups.Selected.AbsoluteIndex > 0);
  var NotIsBaseNode: Boolean := RzShellTreeGroups.Selected.AbsoluteIndex > 0;
  menuitemRenameProjectGroup.Enabled := NotIsBaseNode;
  menuitemRemoveProjectGroup.Enabled := NotIsBaseNode;
end;

function TformMain.ClipboardGetAsFile: string;
var
  Data: THandle;
begin
  Result := '';
  Clipboard.Open;
  Data := GetClipboardData(CF_FILE);
  try
    if Data <> 0 then
      Result := PChar(GlobalLock(Data));
  finally
    if Data <> 0 then
      GlobalUnlock(Data);
    Clipboard.Close;
  end;
end;

function TformMain.IsExistingProjectFileInClipboard: Boolean;
var
  ThisFile: string;
begin
  Result := False;
  if Clipboard.HasFormat(CF_FILE) then
  begin
    ThisFile := ClipboardGetAsFile;
    if SameText(ExtractFileExt(ThisFile), '.DPROJ') then
    begin
      if FileExists(ThisFile) then
        Result := True;
    end;
  end;
end;

procedure TformMain.menuitemRenameProjectGroupClick(Sender: TObject);
begin
  if RzShellTreeGroups.Selected.AbsoluteIndex = 0 then EXIT;
  var ThisSelectedFullPath := (RzShellTreeGroups.GetDataFromNode(RzShellTreeGroups.Selected)).PathName;
  var ThisSelectedFolderName := System.SysUtils.ExtractFileName(ThisSelectedFullPath);
  var aNewFolderName: string := ThisSelectedFolderName + ' New';
  var InputIsValid: Boolean;
  var InputPrompt: string := 'Enter the new name of the Project Group:';
  repeat
    if Vcl.Dialogs.InputQuery('Rename Project Group: ' + ThisSelectedFolderName, InputPrompt, aNewFolderName) then
    begin
      var NewPrompt: string;
      InputIsValid := CheckInput(aNewFolderName, NewPrompt, Purpose_RENAME);
      if not InputIsValid then
        InputPrompt := NewPrompt
      else
      begin
        var FullPathRenameFrom := (RzShellTreeGroups.GetDataFromNode(RzShellTreeGroups.Selected)).PathName;
        var ThisParentFolderPath :=  IncludeTrailingPathDelimiter(System.SysUtils.ExtractFilePath((RzShellTreeGroups.GetDataFromNode(RzShellTreeGroups.Selected)).PathName));
        var FullPathRenameTo := ThisParentFolderPath + aNewFolderName;

        Screen.Cursor := crHourGlass;
        try
          if not DirectoryExists(FullPathRenameTo) then
          begin
            System.SysUtils.RenameFile(FullPathRenameFrom, FullPathRenameTo);
            DoUpdateGroupsControl;
          end;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end
    else
      BREAK;
  until InputIsValid;
end;

procedure TformMain.ResetOldGroupSelection(const aOldFullPath: string);
begin
  RzShellTreeGroups.FullExpand;
  for var i := 0 to RzShellTreeGroups.Items.Count - 1 do
  begin
    if SameText((RzShellTreeGroups.GetDataFromNode(RzShellTreeGroups.Items[i])).PathName, aOldFullPath) then
    begin
      RzShellTreeGroups.Items[i].Selected := True;
      BREAK;
    end;
  end;
end;

procedure TformMain.DoUpdateGroupsControl;
begin
  RzShellTreeGroups.Items.BeginUpdate;
  try
    var ThisBasePath := RzShellTreeGroups.BaseFolder.PathName;
    var OldFullPath := (RzShellTreeGroups.GetDataFromNode(RzShellTreeGroups.Selected)).PathName;

    RzShellTreeGroups.BaseFolder.PathName := ExtractFilePath(ThisBasePath);
    RzShellTreeGroups.BaseFolder.PathName := ThisBasePath;

    ResetOldGroupSelection(OldFullPath);
    RzShellTreeGroups.FullExpand;
    DoAppendGroupNodesInformation;
  finally
    RzShellTreeGroups.Items.EndUpdate;
  end;
end;

procedure TformMain.menuitemCreateASubProjectGroupClick(Sender: TObject);
begin
  var aNewFolderName: string := 'New Project Group';
  var InputIsValid: Boolean;
  var InputPrompt: string := 'Enter the name of the new Project Group:';
  var ThisParentFolderName := System.SysUtils.ExtractFileName((RzShellTreeGroups.GetDataFromNode(RzShellTreeGroups.Selected)).PathName);
  repeat
    if Vcl.Dialogs.InputQuery('Create new Project Group in: ' + ThisParentFolderName, InputPrompt, aNewFolderName) then
    begin
      var NewPrompt: string;
      InputIsValid := CheckInput(aNewFolderName, NewPrompt, Purpose_CREATE);
      if not InputIsValid then
        InputPrompt := NewPrompt
      else
      begin
        var ThisSelectedFullPath := (RzShellTreeGroups.GetDataFromNode(RzShellTreeGroups.Selected)).PathName;
        var NewFullPath := System.SysUtils.IncludeTrailingPathDelimiter(ThisSelectedFullPath) + Trim(aNewFolderName);
        Screen.Cursor := crHourGlass;
        try
          if not DirectoryExists(NewFullPath) then
          begin
            System.SysUtils.CreateDir(NewFullPath);
            DoUpdateGroupsControl;
          end;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    end
    else
      BREAK;
  until InputIsValid;
end;

function PAIsFilenameValid(const AFilename: string; var errorchar: Char): Boolean;
begin
  Result := True;

  for var i := 1 to Length(AFilename) do
  begin
    if not System.IOUtils.TPath.IsValidFileNameChar(AFilename[i]) then
    begin
      errorchar := AFilename[i];
      Result := False;
      BREAK;
    end;
  end;
end;

procedure TformMain.btnCloseAboutClick(Sender: TObject);
begin
  CardPanelMain.ActiveCard := cardMain;
end;

procedure TformMain.btnRemoveSelProjectFromGroupClick(Sender: TObject);
begin
  if MessageBoxW(Handle,
    PWideChar('Do you really want to REMOVE this selected Project from the selected/highlighted Project GROUP(s)?' + #13#10#13#10
    + '(However, the Project is not removed from the MRU Project list)'),
    PWideChar(Application.Title), MB_OKCANCEL + MB_ICONQUESTION + MB_TOPMOST) = IDCANCEL then EXIT;

  if lvMRUProjects.SelCount <> 1 then EXIT;
  if not Assigned(RzShellTreeGroups.Selected) then EXIT;

  var LinkFileToRemove: string;
  if lvMRUProjects.Selected.SubItems.Count = 3 then
    LinkFileToRemove := lvMRUProjects.Selected.SubItems[2];

  if FileExists(LinkFileToRemove) then
  begin
    System.IOUtils.TFile.Delete(LinkFileToRemove);

    DoUpdateGroupsControl;
    ResetGroupsFonts;

    CardPanelProjectDetails.ActiveCard := cardNoProjectSelected;

    DoListTheProjectsFromSelectedProjectGroup;

    RzShellTreeGroups.Invalidate;
    RzShellTreeGroups.Repaint;
    RzShellTreeGroups.Update;
  end;
end;

function TformMain.CheckInput(const aNewFolderName: string; out aNewPrompt: string; const aPurpose: string): Boolean;
begin
  Result := True;
  var errorchar: Char;
  if Trim(aNewFolderName) = '' then
  begin
    aNewPrompt := 'Error: You must enter a Group name:';
    Result := False;
    EXIT;
  end
  else if not PAIsFilenameValid(aNewFolderName, errorchar) then
  begin
    aNewPrompt := 'Error: No illegal characters (' + errorchar + '):';
    Result := False;
  end
  else if TRegEx.IsMatch(Trim(aNewFolderName), '(\(\d+\))\z', [roIgnoreCase]) then
  begin
    aNewPrompt := 'Error: No numbers in brackets at the end:';
    Result := False;
  end;

  if aPurpose = Purpose_CREATE then
  begin
    if DirectoryExists(IncludeTrailingPathDelimiter((RzShellTreeGroups.GetDataFromNode(RzShellTreeGroups.Selected)).PathName) + aNewFolderName) then
    begin
      aNewPrompt := 'Error: This Project Group already exists:';
      Result := False;
    end
  end
  else if aPurpose = Purpose_RENAME then
  begin
    var ThisParentFolderPath :=  IncludeTrailingPathDelimiter(System.SysUtils.ExtractFilePath((RzShellTreeGroups.GetDataFromNode(RzShellTreeGroups.Selected)).PathName));
    if DirectoryExists(ThisParentFolderPath + aNewFolderName) then
    begin
      aNewPrompt := 'Error: This Project Group already exists:';
      Result := False;
    end
  end
end;

procedure TformMain.menuitemRemoveProjectGroupClick(Sender: TObject);
begin
  var ThisDirectory := (RzShellTreeGroups.GetDataFromNode(RzShellTreeGroups.Selected)).PathName;
  var ThisFolderName := System.SysUtils.ExtractFileName(ThisDirectory);
  if MessageBoxW(Handle,
    PWideChar('REMOVE Project Group: ' + ThisFolderName + #13#10#13#10 + 'Do you really want to REMOVE this selected Project Group and all its content and Project references it contains?'),
    PWideChar(Application.Title), MB_OKCANCEL + MB_ICONQUESTION + MB_TOPMOST) = IDOK then
  begin
    if DirectoryExists(ThisDirectory) then
    begin
      System.IOUtils.TDirectory.Delete(ThisDirectory, True);
    end;
  end;
end;

procedure TformMain.RzShellTreeGroupsMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Pt: Winapi.Windows.TPoint;
begin
  var ThisTreeNode := RzShellTreeGroups.GetNodeAt(X, Y);

  if Button = mbRight then
  begin
    if Assigned(ThisTreeNode) then
    begin
      ThisTreeNode.Selected := True;
    end;

    Pt.X := X;
    Pt.Y := Y;
    Pt := RzShellTreeGroups.ClientToScreen(Pt);

    pmProjectGroups.Popup(Pt.X, Pt.Y);
  end
  else if Button = mbLeft then
  begin
    DoShowGroupProjects(ThisTreeNode);
    CardPanelProjectDetails.ActiveCard := cardNoProjectSelected;
  end;
end;

procedure TformMain.DoShowGroupProjects(aTreeNode: TTreeNode);
begin
  if Assigned(aTreeNode) then
  begin
    if (aTreeNode.AbsoluteIndex > 0) then
      DoListTheProjectsFromSelectedProjectGroup
    else if (aTreeNode.AbsoluteIndex = 0) then
    begin
      DoListTheProjectsFromSelectedProjectGroup;
    end;
  end;
end;

procedure TformMain.SetProjectListGroupMode(aGroupMode: Boolean);
begin
  FProjectListGroupMode := aGroupMode;

  var ThisIconGray := TIcon.Create;
  var ThisIconBlue := TIcon.Create;
  try
    ilHeader.GetIcon(5, ThisIconGray);
    ilHeader.GetIcon(4, ThisIconBlue);

    if aGroupMode then
    begin
      imgHeader.Picture.Icon.Assign(ThisIconGray);
      imgHeaderGroup.Picture.Icon.Assign(ThisIconBlue);
      SetProjectListModeCaption('Project-List Mode: GROUP-MODE');
      menuitemMODE_GROUP.Checked := True;
    end
    else
    begin
      SetProjectListModeCaption('Project-List Mode: MRU-MODE');
      ilHeader.GetIcon(3, imgHeaderGroup.Picture.Icon);
      menuitemMODE_MRU.Checked := True;
    end;
  finally
    ThisIconBlue.Free;
    ThisIconGray.Free;
  end;
end;

procedure TformMain.SetProjectListModeCaption(const aCaption: string);
begin
  lblheaderListMode.Caption := aCaption;
  imgHeaderModeDropdownGray.Left := lblheaderListMode.Left - 16;
end;

procedure TformMain.DoListTheProjectsFromSelectedProjectGroup(NotClearProjectList: Boolean = False);
var
  ThisProjectList: TStringList;
  LSearchOption: TSearchOption;
begin
  if not NotClearProjectList then
    SetProjectListGroupMode(True);

  ThisProjectList := TStringList.Create;
  try
    ThisProjectList.Sorted := True;
    ThisProjectList.Duplicates := dupIgnore;

    if ToggleSwitchGroupRecursive.State = tssOn then
      LSearchOption := System.IOUtils.TSearchOption.soAllDirectories
    else
      LSearchOption := System.IOUtils.TSearchOption.soTopDirectoryOnly;

    var SelectedGroupDirectory := (RzShellTreeGroups.GetDataFromNode(RzShellTreeGroups.Selected)).PathName;

    var LList: System.Types.TStringDynArray;
    LList := TDirectory.GetFiles(SelectedGroupDirectory, '*.LNK', LSearchOption);
    for var i := 0 to Length(LList) - 1 do
    begin
      var TargetFileOfExistingLink := GetTargetFileFromLinkFile(LList[i]);
      if Fileexists(TargetFileOfExistingLink) then
      begin
        ThisProjectList.AddPair(TargetFileOfExistingLink, LList[i]);
      end;
    end;

    lvMRUProjects.Items.BeginUpdate;
    try
      if not NotClearProjectList then
        lvMRUProjects.Clear;
      for var i := 0 to ThisProjectList.Count - 1 do
      begin
        var ThisFileExists := FileExists(ThisProjectList.Names[i]);
        if not ThisFileExists then
        begin
          if chkHideNonExistingProjectFiles.Checked or btnTempHideNonExistingFiles.Down then
            CONTINUE;
        end;
        with lvMRUProjects.Items.Add do
        begin
          Caption := ThisProjectList.Names[i];
          if ThisFileExists then
          begin
            SubItems.Add(GetModifiedDateStr(ThisProjectList.Names[i]));
            ImageIndex := 5;
          end
          else
          begin
            SubItems.Add(UNKNOWNSTR);
            ImageIndex := 4;
          end;

          SubItems.Add('');
          SubItems.Add(ThisProjectList.ValueFromIndex[i]);
        end;
      end;
    finally
      lvMRUProjects.Items.EndUpdate;
    end;
  finally
    ThisProjectList.Free;
  end;
  NewListInit;
  if FOldSortedColumn <> -1 then
    DoColumnSort(lvMRUProjects, FSortedColumn, False);
  UncheckAllpmGroupMenuItems;
  btnRemoveSelProjectFromGroup.Enabled := lvMRUProjects.SelCount <> 0;
end;

procedure TformMain.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (CardPanelMain.ActiveCard = cardAbout) then
  begin
    if Key = VK_ESCAPE then
      CardPanelMain.ActiveCard := cardMain;
  end;

  case Key of
    VK_F12: DoTogglePreferences;
    VK_F10: menuitemTitleBarAbout.Click;
  end;
end;

procedure TformMain.DoTogglePreferences;
begin
  if CardPanelMain.ActiveCard <> cardPreferences then
    CardPanelMain.ActiveCard := cardPreferences
  else
    CardPanelMain.ActiveCard := cardMain;
end;

procedure TformMain.lblAboutEmailClick(Sender: TObject);
begin
  Winapi.ShellAPI.ShellExecute(0, 'Open', PChar('mailto:?to=feedback@pa-soft.com&subject=Delphi MRU Project Manager ' + FCurrentProductVersion), nil, nil, SW_SHOWNORMAL);
end;

procedure TformMain.lblAboutHomepageClick(Sender: TObject);
begin
  Winapi.ShellAPI.ShellExecute(0, 'Open', 'https://www.pa-soft.com/freeware.html#ZUFUYmki', nil, nil, SW_SHOWNORMAL);
end;

procedure TformMain.ShowModeSelectionDropdownMenu;
var
  Pt: Winapi.Windows.TPoint;
begin
  Pt.X := lblheaderListMode.Left;
  Pt.Y := lblheaderListMode.Top + lblheaderListMode.Height;
  Pt := lblheaderListMode.Parent.ClientToScreen(Pt);
  pmProjectListMode.Popup(Pt.X, Pt.Y);
end;

procedure TformMain.lblheaderListModeClick(Sender: TObject);
begin
  ShowModeSelectionDropdownMenu;

end;

procedure TformMain.lblheaderListModeMouseEnter(Sender: TObject);
begin
  lblheaderListMode.Font.Color := clWindowText;
end;

procedure TformMain.lblheaderListModeMouseLeave(Sender: TObject);
begin
  lblheaderListMode.Font.Color := clGrayText;
end;

function CurrentProcessMemory: Cardinal;
var
  MemCounters: TProcessMemoryCounters;
begin
  Result := 0;
  MemCounters.cb := SizeOf(MemCounters);
  if GetProcessMemoryInfo(GetCurrentProcess, @MemCounters, SizeOf(MemCounters)) then
    Result := MemCounters.WorkingSetSize
  else
    RaiseLastOSError;
end;

function ConvertFormatFileSizeBytes(Bytes: Int64): string;
const
  Description: array[0..8] of string = ('Bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');
var
  i: Integer;
begin
  i := 0;
  while Bytes > System.Math.Power(1024, i + 1) do
    Inc(i);
  Result := FormatFloat('###0.##', Bytes / System.Math.Power(1024, i)) + #32 + Description[i];
end;

procedure TformMain.AppEventsMainDeactivate(Sender: TObject);
begin
  if not Self.CustomTitleBar.SystemColors then
  begin
    FOldTitleBarColor := Self.CustomTitleBar.BackgroundColor;
    DoSetCustomTitleBarColors(RzCommon.LighterColor(Self.CustomTitleBar.BackgroundColor, 16));
  end;
end;

procedure TformMain.AppEventsMainActivate(Sender: TObject);
begin
  if not Self.CustomTitleBar.SystemColors then
  begin
    DoSetCustomTitleBarColors(FOldTitleBarColor);
  end;
end;

procedure TformMain.btnShowPropertiesDialogClick(Sender: TObject);
begin

  if Self.FormStyle = fsStayOnTop then
    SetStayOnTopPushPinToNormal;

  ShowPropertiesDialog(ParamStr(0));
end;

procedure TformMain.ShowPropertiesDialog(const FileName: string);
var
  sei: Winapi.ShellAPI.TShellExecuteInfo;
begin
  System.FillChar(sei, SizeOf(sei), 0);
  sei.cbSize := System.SizeOf(sei);
  sei.lpFile := PChar(FileName);
  sei.lpVerb := 'properties';
  sei.fMask  := SEE_MASK_INVOKEIDLIST;
  Winapi.ShellAPI.ShellExecuteEx(@sei);
end;

procedure TformMain.chkCustomizeRowHeightClick(Sender: TObject);
begin
  nbRowheight.Update;
end;

procedure TformMain.ResetTitleBarColors;
begin
    with Self.CustomTitleBar do
    begin
      SystemButtons := True;
      SystemColors := True;
      AdjustMyTitleBarControls(BackgroundColor);
    end;
  end;

procedure TformMain.chkCustomizeTitleBarColorClick(Sender: TObject);
begin
  if chkCustomizeTitleBarColor.Checked then
  begin
    if not Self.Visible then EXIT;

    with Self.CustomTitleBar do
    begin
      dlgColorMain.Color := BackgroundColor;
      if dlgColorMain.Execute then
        DoSetCustomTitleBarColors(dlgColorMain.Color)
      else
      begin
        ResetTitleBarColors;
        chkCustomizeTitleBarColor.Checked := False;
      end;
    end;
  end
  else
  begin
    ResetTitleBarColors;
  end;
end;

procedure TformMain.DoSetCustomTitleBarColors(const aColor: TColor);

  function GetBlackOrWhiteContrastColor(const Color: TColor): TColor;
  begin
    if (GetRValue(Color) + GetGValue(Color) + GetBValue(Color)) > 384 then
      result := clBlack
    else
      result := clWhite;
  end;
begin
  with Self.CustomTitleBar do
  begin
    SystemButtons                 := False;
    SystemColors                  := False;
    BackgroundColor               := aColor;
    ButtonBackgroundColor         := aColor;
    ButtonHoverBackgroundColor    := RzCommon.DarkerColor(aColor, 32);
    ButtonInactiveBackgroundColor := RzCommon.LighterColor(aColor, 32);
    ButtonPressedBackgroundColor  := aColor;
    InactiveBackgroundColor       := RzCommon.LighterColor(aColor, 32);
    ForegroundColor               := GetBlackOrWhiteContrastColor(aColor);
  end;
  AdjustMyTitleBarControls(aColor);
end;

procedure TformMain.AdjustMyTitleBarControls(const aColor: TColor);
begin
  pnlTitleBarMenu.Color := aColor;
end;

procedure TformMain.btnPasteProjectClick(Sender: TObject);
begin
  var ThisProjectFromClipboard: string := '';
  if Vcl.Clipbrd.Clipboard.AsText <> '' then
  begin
    ThisProjectFromClipboard := Vcl.Clipbrd.Clipboard.AsText;
  end
  else if IsExistingProjectFileInClipboard then
  begin
    ThisProjectFromClipboard := ClipboardGetAsFile;
  end;
  DoSearchProject(ThisProjectFromClipboard);
end;

procedure TformMain.chkShowInfoTipsClick(Sender: TObject);
begin
  var ThisActive := chkShowInfoTips.Checked;

  lblHintHidePause.Enabled := ThisActive;
  nbHintHidePause.Enabled  := ThisActive;
  lblSeconds.Enabled       := ThisActive;

  SetHintProperties;
end;

procedure TformMain.DoShowAboutCard;
begin
  CardPanelMain.ActiveCard := cardAbout;
end;

procedure TformMain.DropFileTargetProjectListDrop(Sender: TObject; ShiftState: TShiftState; APoint: TPoint; var Effect: Integer);
begin
  var DroppedFiles := TStringList.Create;
  try
    DroppedFiles.Text := DropFileTargetProjectList.Files.Text;
    if DroppedFiles.Count > 0 then
      DoSearchProject(DroppedFiles[0]);
  finally
    DroppedFiles.Free;
  end;
end;

procedure TformMain.FormShow(Sender: TObject);
begin
  PostMessage(Self.Handle, WM_AFTER_SHOW, 0, 0);
end;

procedure TformMain.imgHeaderModeDropdownGrayClick(Sender: TObject);
begin
  ShowModeSelectionDropdownMenu;
end;

procedure TformMain.imgHeaderModeDropdownGrayMouseEnter(Sender: TObject);
begin
  lblheaderListMode.Font.Color := clWindowText;
end;

procedure TformMain.imgHeaderModeDropdownGrayMouseLeave(Sender: TObject);
begin
  lblheaderListMode.Font.Color := clGrayText;
end;

procedure TformMain.imgTitleBarMenuClick(Sender: TObject);
var
  Pt: Winapi.Windows.TPoint;
begin
  Pt.X := imgTitleBarMenu.Left;
  Pt.Y := imgTitleBarMenu.Top + imgTitleBarMenu.Height;
  Pt := imgTitleBarMenu.Parent.ClientToScreen(Pt);
  pmTitleBar.Popup(Pt.X, Pt.Y);
end;

procedure TformMain.imgTitleBarMenuMouseEnter(Sender: TObject);
begin
  pnlTitleBarMenu.Color := RzCommon.DarkerColor(Self.CustomTitleBar.BackgroundColor, 32);
end;

procedure TformMain.imgTitleBarMenuMouseLeave(Sender: TObject);
begin
  pnlTitleBarMenu.Color := Self.CustomTitleBar.BackgroundColor;
end;

procedure TformMain.menuitemMODE_COMBINEDClick(Sender: TObject);
begin
  SetSelectedProjectListMode;
end;

procedure TformMain.menuitemMODE_GROUPClick(Sender: TObject);
begin
  SetSelectedProjectListMode;
end;

procedure TformMain.menuitemMODE_MRUClick(Sender: TObject);
begin
  SetSelectedProjectListMode;
end;

procedure TformMain.SetSelectedProjectListMode;
begin
  if menuitemMODE_MRU.Checked then
  begin
    if Assigned(FClickedMenuItem) then
    begin
      FClickedMenuItem.Click;
      lvMRUProjects.SetFocus;
      FProjectListGroupMode := False;
      SetProjectListGroupMode(False);
    end
  end
  else if menuitemMODE_GROUP.Checked then
  begin
    if Assigned(RzShellTreeGroups.Selected) then
      DoShowGroupProjects(RzShellTreeGroups.Selected);
    ResetGroupsFonts;
    RzShellTreeGroups.SetFocus;
    FProjectListGroupMode := True;
  end
  else if menuitemMODE_COMBINED.Checked then
  begin
    ReClickClickedmenuItem;

    DoListTheProjectsFromSelectedProjectGroup(True);
    CardPanelProjectDetails.ActiveCard := cardNoProjectSelected;

    SetProjectListModeCaption('Project-List Mode: COMBINED MODE');
    menuitemMODE_COMBINED.Checked := True;
    ShowUnfilteredStatus;
  end;

  CardPanelProjectDetails.ActiveCard := cardNoProjectSelected;
end;

procedure TformMain.menuitemPastePlainTextClick(Sender: TObject);
begin
  var ClipboardPlainText := Vcl.Clipbrd.Clipboard.AsText;
  richeditNotesEditor.SelText := ClipboardPlainText;
end;

procedure TformMain.menuitemTitleBarAboutClick(Sender: TObject);
begin
  lblAboutProcessMemory.Caption := 'Process Memory: ' + ConvertFormatFileSizeBytes(CurrentProcessMemory);
  DoShowAboutCard;
end;

procedure TformMain.menuitemTitleBarPreferencesClick(Sender: TObject);
begin
  DoTogglePreferences;
end;

procedure TformMain.menuitemTitleBarShowTheMainPageClick(Sender: TObject);
begin
  CardPanelMain.ActiveCard := cardMain;
end;

procedure TformMain.nbHintHidePauseChange(Sender: TObject);
begin
  SetHintProperties;
end;

procedure TformMain.richeditNotesEditorKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Shift = [ssCtrl] then
  begin
    case Key of
      VK_S_:
        begin
          if btnSaveRTF.Enabled then
            btnSaveRTF.Click;
        end;
    end;
  end;
end;

procedure TformMain.RzShellTreeGroupsCustomDrawItem(Sender: TCustomTreeView; Node: TTreeNode; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
  if lvMRUProjects.SelCount <> 1 then
  begin
    EXIT;
  end;
  if NodeFolderContainsLinkToSelectedProject(Node) then
  begin
    Sender.Canvas.Font.Color := clBlue;
    Sender.Canvas.Font.Style := [fsBold];
  end
  else
  begin
    Sender.Canvas.Font.Color := clWindowText;
    Sender.Canvas.Font.Style := [];
  end;
end;

function TformMain.NodeFolderContainsLinkToSelectedProject(aNode: TTreeNode): Boolean;
var
  LList: System.Types.TStringDynArray;
begin
  Result := False;
  var ThisNodePath := (RzShellTreeGroups.GetDataFromNode(aNode)).PathName;
  LList := TDirectory.GetFiles(ThisNodePath, '*.LNK', TSearchOption.soTopDirectoryOnly);
  if Length(LList) = 0 then EXIT;
  var TargetFileOfExistingLink: string;
  for var i := 0 to Length(LList) - 1 do
  begin
    TargetFileOfExistingLink := GetTargetFileFromLinkFile(LList[i]);
    if SameText(TargetFileOfExistingLink, lvMRUProjects.Selected.Caption) then
    begin
      Result := True;
      BREAK;
    end;
  end;
end;

procedure TformMain.pmOpenInIDEPopup(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  try
    SetCheckedStatusOfLaunchIDEMenuItems;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TformMain.SetCheckedStatusOfLaunchIDEMenuItems;
begin
  var ThisBdsExeFilePath: string;
  for var i := 0 to pmOpenInIDE.Items.Count - 1 do
  begin
    if not pmOpenInIDE.Items[i].Visible then CONTINUE;

    ThisBdsExeFilePath := pmOpenInIDE.Items[i].Hint;
    if not FileExists(ThisBdsExeFilePath) then
    begin
      pmOpenInIDE.Items[i].Enabled := False;
      CONTINUE;
    end
    else
      pmOpenInIDE.Items[i].Enabled := True;

    pmOpenInIDE.Items[i].Checked := ProcessExists(ThisBdsExeFilePath);
  end;
end;

procedure TformMain.pmTitleBarPopup(Sender: TObject);
begin
  menuitemTitleBarShowTheMainPage.Enabled := CardPanelMain.ActiveCard <> cardMain;
end;

procedure TformMain.pnlTitleBarCustomButtons0Click(Sender: TObject);
begin
  if FPushPinImageIndex = 6 then
  begin
    FPushPinImageIndex := 7;
    Self.FormStyle := fsStayOnTop;
  end
  else
  begin
    SetStayOnTopPushPinToNormal;
  end;
end;

procedure TformMain.SetStayOnTopPushPinToNormal;
begin
  FPushPinImageIndex := 6;
  Self.FormStyle := fsNormal;
end;

procedure TformMain.pnlTitleBarCustomButtons0Paint(Sender: TObject);
var
  X, Y: Integer;
  SysButton: TSystemTitleBarButton;
begin
  SysButton := TSystemTitleBarButton(Sender);
  X := SysButton.ClientRect.Left + (SysButton.ClientRect.Width - 32) div 2;
  Y := SysButton.ClientRect.Top + (SysButton.ClientRect.Height - 32) div 2;
  ilHeader.Draw(SysButton.Canvas, X, Y, FPushPinImageIndex);
end;

procedure TformMain.ResetGroupsFonts;
var
  Node: TTreeNode;
begin
  RzShellTreeGroups.Items.BeginUpdate;
  try
    for Node in RzShellTreeGroups.Items do
    begin
      RzShellTreeGroups.Canvas.Font.Color := clWindowText;
      RzShellTreeGroups.Canvas.Font.Style := [];
    end;
  finally
    RzShellTreeGroups.Items.EndUpdate;
  end;
  RzShellTreeGroups.Invalidate;
  RzShellTreeGroups.Repaint;
  RzShellTreeGroups.Update;
end;

procedure TformMain.RzShellTreeGroupsClick(Sender: TObject);
begin
  ResetGroupsFonts;
end;

procedure TformMain.ToggleSwitchGroupRecursiveClick(Sender: TObject);
begin
  if ToggleSwitchGroupRecursive.State = tssOn then
    ToggleSwitchGroupRecursive.ThumbColor := $00FFC391
  else
    ToggleSwitchGroupRecursive.ThumbColor := $0091E7FF;

  if FProjectListGroupMode then
    DoListTheProjectsFromSelectedProjectGroup;
end;

end.

